function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);
var antd = require('antd');
var moment = _interopDefault(require('moment'));
require('react-is');
require('s-platform/dist/index.css');

var styles = {"test":"_3ybTi"};

var CONVERSATION_TYPE = {
  MESSENGER: 'messenger',
  ZALO: 'zalo'
};
var CONST = {
  CONVERSATION_TYPE: CONVERSATION_TYPE,
  EVENT: {
    WEBHOOK_FACEBOOK: 'webhook_facebook',
    WEBHOOK_ZALO: 'webhook_zalo'
  }
};

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor);
  }
}
function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  Object.defineProperty(Constructor, "prototype", {
    writable: false
  });
  return Constructor;
}
function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
function _toPrimitive(input, hint) {
  if (typeof input !== "object" || input === null) return input;
  var prim = input[Symbol.toPrimitive];
  if (prim !== undefined) {
    var res = prim.call(input, hint || "default");
    if (typeof res !== "object") return res;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return (hint === "string" ? String : Number)(input);
}
function _toPropertyKey(arg) {
  var key = _toPrimitive(arg, "string");
  return typeof key === "symbol" ? key : String(key);
}

var FbConversations = function FbConversations(props) {
  var shopId = props.shopId,
    pageId = props.pageId,
    _props$indexDefault = props.indexDefault,
    indexDefault = _props$indexDefault === void 0 ? 0 : _props$indexDefault,
    _props$actionGetFbCon = props.actionGetFbConversations,
    actionGetFbConversations = _props$actionGetFbCon === void 0 ? function () {} : _props$actionGetFbCon,
    _props$onSelectConver = props.onSelectConversation,
    onSelectConversation = _props$onSelectConver === void 0 ? function () {} : _props$onSelectConver,
    _props$fetchingDone = props.fetchingDone,
    fetchingDone = _props$fetchingDone === void 0 ? function () {} : _props$fetchingDone,
    _props$tags = props.tags,
    tags = _props$tags === void 0 ? {} : _props$tags,
    _props$socket = props.socket,
    socket = _props$socket === void 0 ? null : _props$socket;
  var _useState = React.useState(true),
    fetchingConversations = _useState[0],
    setFetchingConversations = _useState[1];
  var _useState2 = React.useState(false),
    loadConversations = _useState2[0],
    setLoadConversations = _useState2[1];
  var _useState3 = React.useState();
  var _useState4 = React.useState(),
    conversation = _useState4[0],
    setConversation = _useState4[1];
  var _useState5 = React.useState([]),
    conversations = _useState5[0],
    setConversations = _useState5[1];
  var _useState6 = React.useState(true),
    isNextPageConversations = _useState6[0];
  var _useState7 = React.useState({
      shopId: shopId,
      page: 0,
      pageSize: 10
    }),
    conversationsParams = _useState7[0],
    setConversationsParams = _useState7[1];
  React.useEffect(function () {
    getListConversation();
  }, [pageId]);
  React.useEffect(function () {
    if (socket) {
      socket.on('webhook_facebook', handleWebhookMessage);
    }
  }, [socket]);
  var getListConversation = function getListConversation() {
    try {
      if (!pageId) return Promise.resolve();
      setLoadConversations(true);
      setFetchingConversations(true);
      return Promise.resolve(actionGetFbConversations(shopId, pageId)).then(function (res) {
        var _res$data, _res$data$data;
        console.log('actionGetFbConversations', res);
        var resDatas = (res === null || res === void 0 ? void 0 : (_res$data = res.data) === null || _res$data === void 0 ? void 0 : (_res$data$data = _res$data.data) === null || _res$data$data === void 0 ? void 0 : _res$data$data.data) || [];
        var _conversations = [];
        resDatas.forEach(function (e) {
          var _e$participants, _e$participants$data, _e$messages, _e$messages$data, _e$messages$data$;
          var partner = e === null || e === void 0 ? void 0 : (_e$participants = e.participants) === null || _e$participants === void 0 ? void 0 : (_e$participants$data = _e$participants.data) === null || _e$participants$data === void 0 ? void 0 : _e$participants$data[0];
          var displayName = (partner === null || partner === void 0 ? void 0 : partner.name) || '';
          var displayAvatar = (partner === null || partner === void 0 ? void 0 : partner.urlAvatar) || '';
          var fbChatUserId = (partner === null || partner === void 0 ? void 0 : partner.id) || '';
          var chatId = (e === null || e === void 0 ? void 0 : e.id) || '';
          var message = (e === null || e === void 0 ? void 0 : (_e$messages = e.messages) === null || _e$messages === void 0 ? void 0 : (_e$messages$data = _e$messages.data) === null || _e$messages$data === void 0 ? void 0 : (_e$messages$data$ = _e$messages$data[0]) === null || _e$messages$data$ === void 0 ? void 0 : _e$messages$data$.message) || '';
          _conversations.push({
            displayName: displayName,
            displayAvatar: displayAvatar,
            message: message,
            time: (e === null || e === void 0 ? void 0 : e.updated_time) || 0,
            chatId: chatId,
            fbChatUserId: fbChatUserId
          });
        });
        setConversations(_conversations);
        setLoadConversations(false);
        setFetchingConversations(false);
        selectConversation(_conversations === null || _conversations === void 0 ? void 0 : _conversations[indexDefault]);
        fetchingDone(_conversations);
      });
    } catch (e) {
      return Promise.reject(e);
    }
  };
  var selectConversation = function selectConversation(_conversation) {
    console.log('_conversation', _conversation);
    if ((_conversation === null || _conversation === void 0 ? void 0 : _conversation.chatId) !== (conversation === null || conversation === void 0 ? void 0 : conversation.chatId)) {
      setConversation(_conversation);
      onSelectConversation(_conversation);
    }
  };
  var handleScroll = function handleScroll(event) {
    var scrollTop = event.currentTarget.scrollTop;
    var scrollHeight = event.currentTarget.scrollHeight;
    var offsetHeight = event.currentTarget.offsetHeight;
    var scrollBottom = scrollHeight - offsetHeight - scrollTop;
    if (scrollBottom < 50 && !loadConversations) {
      console.log('bottom');
      if (isNextPageConversations) {
        setConversationsParams(_extends({}, conversationsParams, {
          page: conversationsParams.page + 1
        }));
      }
    }
  };
  var handleWebhookMessage = function handleWebhookMessage(event) {
    setConversations(function (conversations) {
      console.log('conversations', conversations);
      var messageDetail = event === null || event === void 0 ? void 0 : event.detailMessageResponse;
      var fbChatUserId = (messageDetail === null || messageDetail === void 0 ? void 0 : messageDetail.toId) === pageId ? messageDetail === null || messageDetail === void 0 ? void 0 : messageDetail.fromId : messageDetail === null || messageDetail === void 0 ? void 0 : messageDetail.toId;
      var index = [].concat(conversations).findIndex(function (e) {
        return (e === null || e === void 0 ? void 0 : e.fbChatUserId) === fbChatUserId;
      });
      console.log('index', index);
      if (index > -1) {
        var _insert;
        var insert = conversations === null || conversations === void 0 ? void 0 : conversations.splice(index, 1);
        console.log('insert', insert);
        console.log('messageDetail', messageDetail);
        insert = _extends({}, (_insert = insert) === null || _insert === void 0 ? void 0 : _insert[0], {
          time: messageDetail === null || messageDetail === void 0 ? void 0 : messageDetail.createdTime
        }, messageDetail);
        console.log('data', insert);
        return [insert].concat(conversations);
      }
      return [].concat(conversations);
    });
  };
  return fetchingConversations ? /*#__PURE__*/React__default.createElement("div", {
    style: {
      padding: 24
    }
  }, /*#__PURE__*/React__default.createElement(antd.Skeleton, {
    loading: true,
    active: true,
    avatar: true
  }), /*#__PURE__*/React__default.createElement(antd.Skeleton, {
    loading: true,
    active: true,
    avatar: true
  }), /*#__PURE__*/React__default.createElement(antd.Skeleton, {
    loading: true,
    active: true,
    avatar: true
  })) : /*#__PURE__*/React__default.createElement("div", {
    onScroll: handleScroll,
    style: {
      display: 'flex',
      flexFlow: 'column',
      overflowY: 'auto',
      marginLeft: 12,
      marginTop: 12
    }
  }, conversations === null || conversations === void 0 ? void 0 : conversations.map(function (e, i) {
    var _moment$fromNow, _moment$fromNow$repla, _tags$e$chatId;
    return /*#__PURE__*/React__default.createElement("div", {
      style: {
        display: 'inline-flex',
        padding: 12,
        cursor: 'pointer',
        borderRadius: 6,
        marginRight: 6,
        backgroundColor: (e === null || e === void 0 ? void 0 : e.chatId) === (conversation === null || conversation === void 0 ? void 0 : conversation.chatId) ? '#f1f1f1' : 'transparent'
      },
      onClick: function onClick() {
        return selectConversation(e);
      },
      key: i
    }, /*#__PURE__*/React__default.createElement("img", {
      src: e === null || e === void 0 ? void 0 : e.displayAvatar,
      style: {
        width: 40,
        height: 40,
        borderRadius: 20,
        objectFit: 'cover',
        backgroundColor: '#f1f1f1'
      }
    }), /*#__PURE__*/React__default.createElement("div", {
      style: {
        marginLeft: 12
      }
    }, /*#__PURE__*/React__default.createElement("div", null, e === null || e === void 0 ? void 0 : e.displayName), /*#__PURE__*/React__default.createElement("div", {
      style: {
        display: 'flex',
        flexDirection: 'row',
        alignItems: 'center',
        fontSize: 12,
        color: '#999',
        marginTop: 2
      }
    }, e !== null && e !== void 0 && e.message ? /*#__PURE__*/React__default.createElement(React.Fragment, null, /*#__PURE__*/React__default.createElement("div", {
      style: {
        maxWidth: 120,
        'white-space': 'nowrap',
        'text-overflow': 'ellipsis',
        overflow: 'hidden'
      }
    }, e === null || e === void 0 ? void 0 : e.message), /*#__PURE__*/React__default.createElement("div", {
      style: {
        width: 2,
        height: 2,
        backgroundColor: '#ccc',
        borderRadius: 2,
        margin: '0px 4px'
      }
    })) : null, /*#__PURE__*/React__default.createElement("div", null, (_moment$fromNow = moment(e === null || e === void 0 ? void 0 : e.time).fromNow()) === null || _moment$fromNow === void 0 ? void 0 : (_moment$fromNow$repla = _moment$fromNow.replace('trước', '')) === null || _moment$fromNow$repla === void 0 ? void 0 : _moment$fromNow$repla.trim())), /*#__PURE__*/React__default.createElement(antd.Space, {
      size: 0,
      style: {
        marginTop: 4
      }
    }, tags === null || tags === void 0 ? void 0 : (_tags$e$chatId = tags[e === null || e === void 0 ? void 0 : e.chatId]) === null || _tags$e$chatId === void 0 ? void 0 : _tags$e$chatId.map(function (e) {
      return /*#__PURE__*/React__default.createElement(antd.Tag, {
        color: e === null || e === void 0 ? void 0 : e.color
      }, e === null || e === void 0 ? void 0 : e.name);
    }))));
  }));
};

var IconContext = /*#__PURE__*/React.createContext({});

function _extends$1() {
  _extends$1 = Object.assign ? Object.assign.bind() : function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends$1.apply(this, arguments);
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArrayLimit(arr, i) {
  var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"];
  if (null != _i) {
    var _s,
      _e,
      _x,
      _r,
      _arr = [],
      _n = !0,
      _d = !1;
    try {
      if (_x = (_i = _i.call(arr)).next, 0 === i) {
        if (Object(_i) !== _i) return;
        _n = !1;
      } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0);
    } catch (err) {
      _d = !0, _e = err;
    } finally {
      try {
        if (!_n && null != _i["return"] && (_r = _i["return"](), Object(_r) !== _r)) return;
      } finally {
        if (_d) throw _e;
      }
    }
    return _arr;
  }
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;
  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];
  return arr2;
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}

function _typeof(obj) {
  "@babel/helpers - typeof";

  return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) {
    return typeof obj;
  } : function (obj) {
    return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
  }, _typeof(obj);
}

function _toPrimitive$1(input, hint) {
  if (_typeof(input) !== "object" || input === null) return input;
  var prim = input[Symbol.toPrimitive];
  if (prim !== undefined) {
    var res = prim.call(input, hint || "default");
    if (_typeof(res) !== "object") return res;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return (hint === "string" ? String : Number)(input);
}

function _toPropertyKey$1(arg) {
  var key = _toPrimitive$1(arg, "string");
  return _typeof(key) === "symbol" ? key : String(key);
}

function _defineProperty(obj, key, value) {
  key = _toPropertyKey$1(key);
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }
  return obj;
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;
  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }
  return target;
}

function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};
  var target = _objectWithoutPropertiesLoose(source, excluded);
  var key, i;
  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }
  return target;
}

function createCommonjsModule(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

var classnames = createCommonjsModule(function (module) {
/*!
	Copyright (c) 2018 Jed Watson.
	Licensed under the MIT License (MIT), see
	http://jedwatson.github.io/classnames
*/
/* global define */

(function () {

	var hasOwn = {}.hasOwnProperty;

	function classNames() {
		var classes = [];

		for (var i = 0; i < arguments.length; i++) {
			var arg = arguments[i];
			if (!arg) continue;

			var argType = typeof arg;

			if (argType === 'string' || argType === 'number') {
				classes.push(arg);
			} else if (Array.isArray(arg)) {
				if (arg.length) {
					var inner = classNames.apply(null, arg);
					if (inner) {
						classes.push(inner);
					}
				}
			} else if (argType === 'object') {
				if (arg.toString !== Object.prototype.toString && !arg.toString.toString().includes('[native code]')) {
					classes.push(arg.toString());
					continue;
				}

				for (var key in arg) {
					if (hasOwn.call(arg, key) && arg[key]) {
						classes.push(key);
					}
				}
			}
		}

		return classes.join(' ');
	}

	if ( module.exports) {
		classNames.default = classNames;
		module.exports = classNames;
	} else {
		window.classNames = classNames;
	}
}());
});

/**
 * Take input from [0, n] and return it as [0, 1]
 * @hidden
 */
function bound01(n, max) {
    if (isOnePointZero(n)) {
        n = '100%';
    }
    var isPercent = isPercentage(n);
    n = max === 360 ? n : Math.min(max, Math.max(0, parseFloat(n)));
    // Automatically convert percentage into number
    if (isPercent) {
        n = parseInt(String(n * max), 10) / 100;
    }
    // Handle floating point rounding errors
    if (Math.abs(n - max) < 0.000001) {
        return 1;
    }
    // Convert into [0, 1] range if it isn't already
    if (max === 360) {
        // If n is a hue given in degrees,
        // wrap around out-of-range values into [0, 360] range
        // then convert into [0, 1].
        n = (n < 0 ? (n % max) + max : n % max) / parseFloat(String(max));
    }
    else {
        // If n not a hue given in degrees
        // Convert into [0, 1] range if it isn't already.
        n = (n % max) / parseFloat(String(max));
    }
    return n;
}
/**
 * Need to handle 1.0 as 100%, since once it is a number, there is no difference between it and 1
 * <http://stackoverflow.com/questions/7422072/javascript-how-to-detect-number-as-a-decimal-including-1-0>
 * @hidden
 */
function isOnePointZero(n) {
    return typeof n === 'string' && n.indexOf('.') !== -1 && parseFloat(n) === 1;
}
/**
 * Check to see if string passed in is a percentage
 * @hidden
 */
function isPercentage(n) {
    return typeof n === 'string' && n.indexOf('%') !== -1;
}
/**
 * Return a valid alpha value [0,1] with all invalid values being set to 1
 * @hidden
 */
function boundAlpha(a) {
    a = parseFloat(a);
    if (isNaN(a) || a < 0 || a > 1) {
        a = 1;
    }
    return a;
}
/**
 * Replace a decimal with it's percentage value
 * @hidden
 */
function convertToPercentage(n) {
    if (n <= 1) {
        return "".concat(Number(n) * 100, "%");
    }
    return n;
}
/**
 * Force a hex value to have 2 characters
 * @hidden
 */
function pad2(c) {
    return c.length === 1 ? '0' + c : String(c);
}

// `rgbToHsl`, `rgbToHsv`, `hslToRgb`, `hsvToRgb` modified from:
// <http://mjijackson.com/2008/02/rgb-to-hsl-and-rgb-to-hsv-color-model-conversion-algorithms-in-javascript>
/**
 * Handle bounds / percentage checking to conform to CSS color spec
 * <http://www.w3.org/TR/css3-color/>
 * *Assumes:* r, g, b in [0, 255] or [0, 1]
 * *Returns:* { r, g, b } in [0, 255]
 */
function rgbToRgb(r, g, b) {
    return {
        r: bound01(r, 255) * 255,
        g: bound01(g, 255) * 255,
        b: bound01(b, 255) * 255,
    };
}
function hue2rgb(p, q, t) {
    if (t < 0) {
        t += 1;
    }
    if (t > 1) {
        t -= 1;
    }
    if (t < 1 / 6) {
        return p + (q - p) * (6 * t);
    }
    if (t < 1 / 2) {
        return q;
    }
    if (t < 2 / 3) {
        return p + (q - p) * (2 / 3 - t) * 6;
    }
    return p;
}
/**
 * Converts an HSL color value to RGB.
 *
 * *Assumes:* h is contained in [0, 1] or [0, 360] and s and l are contained [0, 1] or [0, 100]
 * *Returns:* { r, g, b } in the set [0, 255]
 */
function hslToRgb(h, s, l) {
    var r;
    var g;
    var b;
    h = bound01(h, 360);
    s = bound01(s, 100);
    l = bound01(l, 100);
    if (s === 0) {
        // achromatic
        g = l;
        b = l;
        r = l;
    }
    else {
        var q = l < 0.5 ? l * (1 + s) : l + s - l * s;
        var p = 2 * l - q;
        r = hue2rgb(p, q, h + 1 / 3);
        g = hue2rgb(p, q, h);
        b = hue2rgb(p, q, h - 1 / 3);
    }
    return { r: r * 255, g: g * 255, b: b * 255 };
}
/**
 * Converts an RGB color value to HSV
 *
 * *Assumes:* r, g, and b are contained in the set [0, 255] or [0, 1]
 * *Returns:* { h, s, v } in [0,1]
 */
function rgbToHsv(r, g, b) {
    r = bound01(r, 255);
    g = bound01(g, 255);
    b = bound01(b, 255);
    var max = Math.max(r, g, b);
    var min = Math.min(r, g, b);
    var h = 0;
    var v = max;
    var d = max - min;
    var s = max === 0 ? 0 : d / max;
    if (max === min) {
        h = 0; // achromatic
    }
    else {
        switch (max) {
            case r:
                h = (g - b) / d + (g < b ? 6 : 0);
                break;
            case g:
                h = (b - r) / d + 2;
                break;
            case b:
                h = (r - g) / d + 4;
                break;
        }
        h /= 6;
    }
    return { h: h, s: s, v: v };
}
/**
 * Converts an HSV color value to RGB.
 *
 * *Assumes:* h is contained in [0, 1] or [0, 360] and s and v are contained in [0, 1] or [0, 100]
 * *Returns:* { r, g, b } in the set [0, 255]
 */
function hsvToRgb(h, s, v) {
    h = bound01(h, 360) * 6;
    s = bound01(s, 100);
    v = bound01(v, 100);
    var i = Math.floor(h);
    var f = h - i;
    var p = v * (1 - s);
    var q = v * (1 - f * s);
    var t = v * (1 - (1 - f) * s);
    var mod = i % 6;
    var r = [v, q, p, p, t, v][mod];
    var g = [t, v, v, q, p, p][mod];
    var b = [p, p, t, v, v, q][mod];
    return { r: r * 255, g: g * 255, b: b * 255 };
}
/**
 * Converts an RGB color to hex
 *
 * Assumes r, g, and b are contained in the set [0, 255]
 * Returns a 3 or 6 character hex
 */
function rgbToHex(r, g, b, allow3Char) {
    var hex = [
        pad2(Math.round(r).toString(16)),
        pad2(Math.round(g).toString(16)),
        pad2(Math.round(b).toString(16)),
    ];
    // Return a 3 character hex if possible
    if (allow3Char &&
        hex[0].startsWith(hex[0].charAt(1)) &&
        hex[1].startsWith(hex[1].charAt(1)) &&
        hex[2].startsWith(hex[2].charAt(1))) {
        return hex[0].charAt(0) + hex[1].charAt(0) + hex[2].charAt(0);
    }
    return hex.join('');
}
/** Converts a hex value to a decimal */
function convertHexToDecimal(h) {
    return parseIntFromHex(h) / 255;
}
/** Parse a base-16 hex value into a base-10 integer */
function parseIntFromHex(val) {
    return parseInt(val, 16);
}

// https://github.com/bahamas10/css-color-names/blob/master/css-color-names.json
/**
 * @hidden
 */
var names = {
    aliceblue: '#f0f8ff',
    antiquewhite: '#faebd7',
    aqua: '#00ffff',
    aquamarine: '#7fffd4',
    azure: '#f0ffff',
    beige: '#f5f5dc',
    bisque: '#ffe4c4',
    black: '#000000',
    blanchedalmond: '#ffebcd',
    blue: '#0000ff',
    blueviolet: '#8a2be2',
    brown: '#a52a2a',
    burlywood: '#deb887',
    cadetblue: '#5f9ea0',
    chartreuse: '#7fff00',
    chocolate: '#d2691e',
    coral: '#ff7f50',
    cornflowerblue: '#6495ed',
    cornsilk: '#fff8dc',
    crimson: '#dc143c',
    cyan: '#00ffff',
    darkblue: '#00008b',
    darkcyan: '#008b8b',
    darkgoldenrod: '#b8860b',
    darkgray: '#a9a9a9',
    darkgreen: '#006400',
    darkgrey: '#a9a9a9',
    darkkhaki: '#bdb76b',
    darkmagenta: '#8b008b',
    darkolivegreen: '#556b2f',
    darkorange: '#ff8c00',
    darkorchid: '#9932cc',
    darkred: '#8b0000',
    darksalmon: '#e9967a',
    darkseagreen: '#8fbc8f',
    darkslateblue: '#483d8b',
    darkslategray: '#2f4f4f',
    darkslategrey: '#2f4f4f',
    darkturquoise: '#00ced1',
    darkviolet: '#9400d3',
    deeppink: '#ff1493',
    deepskyblue: '#00bfff',
    dimgray: '#696969',
    dimgrey: '#696969',
    dodgerblue: '#1e90ff',
    firebrick: '#b22222',
    floralwhite: '#fffaf0',
    forestgreen: '#228b22',
    fuchsia: '#ff00ff',
    gainsboro: '#dcdcdc',
    ghostwhite: '#f8f8ff',
    goldenrod: '#daa520',
    gold: '#ffd700',
    gray: '#808080',
    green: '#008000',
    greenyellow: '#adff2f',
    grey: '#808080',
    honeydew: '#f0fff0',
    hotpink: '#ff69b4',
    indianred: '#cd5c5c',
    indigo: '#4b0082',
    ivory: '#fffff0',
    khaki: '#f0e68c',
    lavenderblush: '#fff0f5',
    lavender: '#e6e6fa',
    lawngreen: '#7cfc00',
    lemonchiffon: '#fffacd',
    lightblue: '#add8e6',
    lightcoral: '#f08080',
    lightcyan: '#e0ffff',
    lightgoldenrodyellow: '#fafad2',
    lightgray: '#d3d3d3',
    lightgreen: '#90ee90',
    lightgrey: '#d3d3d3',
    lightpink: '#ffb6c1',
    lightsalmon: '#ffa07a',
    lightseagreen: '#20b2aa',
    lightskyblue: '#87cefa',
    lightslategray: '#778899',
    lightslategrey: '#778899',
    lightsteelblue: '#b0c4de',
    lightyellow: '#ffffe0',
    lime: '#00ff00',
    limegreen: '#32cd32',
    linen: '#faf0e6',
    magenta: '#ff00ff',
    maroon: '#800000',
    mediumaquamarine: '#66cdaa',
    mediumblue: '#0000cd',
    mediumorchid: '#ba55d3',
    mediumpurple: '#9370db',
    mediumseagreen: '#3cb371',
    mediumslateblue: '#7b68ee',
    mediumspringgreen: '#00fa9a',
    mediumturquoise: '#48d1cc',
    mediumvioletred: '#c71585',
    midnightblue: '#191970',
    mintcream: '#f5fffa',
    mistyrose: '#ffe4e1',
    moccasin: '#ffe4b5',
    navajowhite: '#ffdead',
    navy: '#000080',
    oldlace: '#fdf5e6',
    olive: '#808000',
    olivedrab: '#6b8e23',
    orange: '#ffa500',
    orangered: '#ff4500',
    orchid: '#da70d6',
    palegoldenrod: '#eee8aa',
    palegreen: '#98fb98',
    paleturquoise: '#afeeee',
    palevioletred: '#db7093',
    papayawhip: '#ffefd5',
    peachpuff: '#ffdab9',
    peru: '#cd853f',
    pink: '#ffc0cb',
    plum: '#dda0dd',
    powderblue: '#b0e0e6',
    purple: '#800080',
    rebeccapurple: '#663399',
    red: '#ff0000',
    rosybrown: '#bc8f8f',
    royalblue: '#4169e1',
    saddlebrown: '#8b4513',
    salmon: '#fa8072',
    sandybrown: '#f4a460',
    seagreen: '#2e8b57',
    seashell: '#fff5ee',
    sienna: '#a0522d',
    silver: '#c0c0c0',
    skyblue: '#87ceeb',
    slateblue: '#6a5acd',
    slategray: '#708090',
    slategrey: '#708090',
    snow: '#fffafa',
    springgreen: '#00ff7f',
    steelblue: '#4682b4',
    tan: '#d2b48c',
    teal: '#008080',
    thistle: '#d8bfd8',
    tomato: '#ff6347',
    turquoise: '#40e0d0',
    violet: '#ee82ee',
    wheat: '#f5deb3',
    white: '#ffffff',
    whitesmoke: '#f5f5f5',
    yellow: '#ffff00',
    yellowgreen: '#9acd32',
};

/* eslint-disable @typescript-eslint/no-redundant-type-constituents */
/**
 * Given a string or object, convert that input to RGB
 *
 * Possible string inputs:
 * ```
 * "red"
 * "#f00" or "f00"
 * "#ff0000" or "ff0000"
 * "#ff000000" or "ff000000"
 * "rgb 255 0 0" or "rgb (255, 0, 0)"
 * "rgb 1.0 0 0" or "rgb (1, 0, 0)"
 * "rgba (255, 0, 0, 1)" or "rgba 255, 0, 0, 1"
 * "rgba (1.0, 0, 0, 1)" or "rgba 1.0, 0, 0, 1"
 * "hsl(0, 100%, 50%)" or "hsl 0 100% 50%"
 * "hsla(0, 100%, 50%, 1)" or "hsla 0 100% 50%, 1"
 * "hsv(0, 100%, 100%)" or "hsv 0 100% 100%"
 * ```
 */
function inputToRGB(color) {
    var rgb = { r: 0, g: 0, b: 0 };
    var a = 1;
    var s = null;
    var v = null;
    var l = null;
    var ok = false;
    var format = false;
    if (typeof color === 'string') {
        color = stringInputToObject(color);
    }
    if (typeof color === 'object') {
        if (isValidCSSUnit(color.r) && isValidCSSUnit(color.g) && isValidCSSUnit(color.b)) {
            rgb = rgbToRgb(color.r, color.g, color.b);
            ok = true;
            format = String(color.r).substr(-1) === '%' ? 'prgb' : 'rgb';
        }
        else if (isValidCSSUnit(color.h) && isValidCSSUnit(color.s) && isValidCSSUnit(color.v)) {
            s = convertToPercentage(color.s);
            v = convertToPercentage(color.v);
            rgb = hsvToRgb(color.h, s, v);
            ok = true;
            format = 'hsv';
        }
        else if (isValidCSSUnit(color.h) && isValidCSSUnit(color.s) && isValidCSSUnit(color.l)) {
            s = convertToPercentage(color.s);
            l = convertToPercentage(color.l);
            rgb = hslToRgb(color.h, s, l);
            ok = true;
            format = 'hsl';
        }
        if (Object.prototype.hasOwnProperty.call(color, 'a')) {
            a = color.a;
        }
    }
    a = boundAlpha(a);
    return {
        ok: ok,
        format: color.format || format,
        r: Math.min(255, Math.max(rgb.r, 0)),
        g: Math.min(255, Math.max(rgb.g, 0)),
        b: Math.min(255, Math.max(rgb.b, 0)),
        a: a,
    };
}
// <http://www.w3.org/TR/css3-values/#integers>
var CSS_INTEGER = '[-\\+]?\\d+%?';
// <http://www.w3.org/TR/css3-values/#number-value>
var CSS_NUMBER = '[-\\+]?\\d*\\.\\d+%?';
// Allow positive/negative integer/number.  Don't capture the either/or, just the entire outcome.
var CSS_UNIT = "(?:".concat(CSS_NUMBER, ")|(?:").concat(CSS_INTEGER, ")");
// Actual matching.
// Parentheses and commas are optional, but not required.
// Whitespace can take the place of commas or opening paren
var PERMISSIVE_MATCH3 = "[\\s|\\(]+(".concat(CSS_UNIT, ")[,|\\s]+(").concat(CSS_UNIT, ")[,|\\s]+(").concat(CSS_UNIT, ")\\s*\\)?");
var PERMISSIVE_MATCH4 = "[\\s|\\(]+(".concat(CSS_UNIT, ")[,|\\s]+(").concat(CSS_UNIT, ")[,|\\s]+(").concat(CSS_UNIT, ")[,|\\s]+(").concat(CSS_UNIT, ")\\s*\\)?");
var matchers = {
    CSS_UNIT: new RegExp(CSS_UNIT),
    rgb: new RegExp('rgb' + PERMISSIVE_MATCH3),
    rgba: new RegExp('rgba' + PERMISSIVE_MATCH4),
    hsl: new RegExp('hsl' + PERMISSIVE_MATCH3),
    hsla: new RegExp('hsla' + PERMISSIVE_MATCH4),
    hsv: new RegExp('hsv' + PERMISSIVE_MATCH3),
    hsva: new RegExp('hsva' + PERMISSIVE_MATCH4),
    hex3: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/,
    hex6: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/,
    hex4: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/,
    hex8: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/,
};
/**
 * Permissive string parsing.  Take in a number of formats, and output an object
 * based on detected format.  Returns `{ r, g, b }` or `{ h, s, l }` or `{ h, s, v}`
 */
function stringInputToObject(color) {
    color = color.trim().toLowerCase();
    if (color.length === 0) {
        return false;
    }
    var named = false;
    if (names[color]) {
        color = names[color];
        named = true;
    }
    else if (color === 'transparent') {
        return { r: 0, g: 0, b: 0, a: 0, format: 'name' };
    }
    // Try to match string input using regular expressions.
    // Keep most of the number bounding out of this function - don't worry about [0,1] or [0,100] or [0,360]
    // Just return an object and let the conversion functions handle that.
    // This way the result will be the same whether the tinycolor is initialized with string or object.
    var match = matchers.rgb.exec(color);
    if (match) {
        return { r: match[1], g: match[2], b: match[3] };
    }
    match = matchers.rgba.exec(color);
    if (match) {
        return { r: match[1], g: match[2], b: match[3], a: match[4] };
    }
    match = matchers.hsl.exec(color);
    if (match) {
        return { h: match[1], s: match[2], l: match[3] };
    }
    match = matchers.hsla.exec(color);
    if (match) {
        return { h: match[1], s: match[2], l: match[3], a: match[4] };
    }
    match = matchers.hsv.exec(color);
    if (match) {
        return { h: match[1], s: match[2], v: match[3] };
    }
    match = matchers.hsva.exec(color);
    if (match) {
        return { h: match[1], s: match[2], v: match[3], a: match[4] };
    }
    match = matchers.hex8.exec(color);
    if (match) {
        return {
            r: parseIntFromHex(match[1]),
            g: parseIntFromHex(match[2]),
            b: parseIntFromHex(match[3]),
            a: convertHexToDecimal(match[4]),
            format: named ? 'name' : 'hex8',
        };
    }
    match = matchers.hex6.exec(color);
    if (match) {
        return {
            r: parseIntFromHex(match[1]),
            g: parseIntFromHex(match[2]),
            b: parseIntFromHex(match[3]),
            format: named ? 'name' : 'hex',
        };
    }
    match = matchers.hex4.exec(color);
    if (match) {
        return {
            r: parseIntFromHex(match[1] + match[1]),
            g: parseIntFromHex(match[2] + match[2]),
            b: parseIntFromHex(match[3] + match[3]),
            a: convertHexToDecimal(match[4] + match[4]),
            format: named ? 'name' : 'hex8',
        };
    }
    match = matchers.hex3.exec(color);
    if (match) {
        return {
            r: parseIntFromHex(match[1] + match[1]),
            g: parseIntFromHex(match[2] + match[2]),
            b: parseIntFromHex(match[3] + match[3]),
            format: named ? 'name' : 'hex',
        };
    }
    return false;
}
/**
 * Check to see if it looks like a CSS unit
 * (see `matchers` above for definition).
 */
function isValidCSSUnit(color) {
    return Boolean(matchers.CSS_UNIT.exec(String(color)));
}

var hueStep = 2; // 色相阶梯

var saturationStep = 0.16; // 饱和度阶梯，浅色部分

var saturationStep2 = 0.05; // 饱和度阶梯，深色部分

var brightnessStep1 = 0.05; // 亮度阶梯，浅色部分

var brightnessStep2 = 0.15; // 亮度阶梯，深色部分

var lightColorCount = 5; // 浅色数量，主色上

var darkColorCount = 4; // 深色数量，主色下
// 暗色主题颜色映射关系表

var darkColorMap = [{
  index: 7,
  opacity: 0.15
}, {
  index: 6,
  opacity: 0.25
}, {
  index: 5,
  opacity: 0.3
}, {
  index: 5,
  opacity: 0.45
}, {
  index: 5,
  opacity: 0.65
}, {
  index: 5,
  opacity: 0.85
}, {
  index: 4,
  opacity: 0.9
}, {
  index: 3,
  opacity: 0.95
}, {
  index: 2,
  opacity: 0.97
}, {
  index: 1,
  opacity: 0.98
}];

// Wrapper function ported from TinyColor.prototype.toHsv
// Keep it here because of `hsv.h * 360`
function toHsv(_ref) {
  var r = _ref.r,
      g = _ref.g,
      b = _ref.b;
  var hsv = rgbToHsv(r, g, b);
  return {
    h: hsv.h * 360,
    s: hsv.s,
    v: hsv.v
  };
} // Wrapper function ported from TinyColor.prototype.toHexString
// Keep it here because of the prefix `#`


function toHex(_ref2) {
  var r = _ref2.r,
      g = _ref2.g,
      b = _ref2.b;
  return "#".concat(rgbToHex(r, g, b, false));
} // Wrapper function ported from TinyColor.prototype.mix, not treeshakable.
// Amount in range [0, 1]
// Assume color1 & color2 has no alpha, since the following src code did so.


function mix(rgb1, rgb2, amount) {
  var p = amount / 100;
  var rgb = {
    r: (rgb2.r - rgb1.r) * p + rgb1.r,
    g: (rgb2.g - rgb1.g) * p + rgb1.g,
    b: (rgb2.b - rgb1.b) * p + rgb1.b
  };
  return rgb;
}

function getHue(hsv, i, light) {
  var hue; // 根据色相不同，色相转向不同

  if (Math.round(hsv.h) >= 60 && Math.round(hsv.h) <= 240) {
    hue = light ? Math.round(hsv.h) - hueStep * i : Math.round(hsv.h) + hueStep * i;
  } else {
    hue = light ? Math.round(hsv.h) + hueStep * i : Math.round(hsv.h) - hueStep * i;
  }

  if (hue < 0) {
    hue += 360;
  } else if (hue >= 360) {
    hue -= 360;
  }

  return hue;
}

function getSaturation(hsv, i, light) {
  // grey color don't change saturation
  if (hsv.h === 0 && hsv.s === 0) {
    return hsv.s;
  }

  var saturation;

  if (light) {
    saturation = hsv.s - saturationStep * i;
  } else if (i === darkColorCount) {
    saturation = hsv.s + saturationStep;
  } else {
    saturation = hsv.s + saturationStep2 * i;
  } // 边界值修正


  if (saturation > 1) {
    saturation = 1;
  } // 第一格的 s 限制在 0.06-0.1 之间


  if (light && i === lightColorCount && saturation > 0.1) {
    saturation = 0.1;
  }

  if (saturation < 0.06) {
    saturation = 0.06;
  }

  return Number(saturation.toFixed(2));
}

function getValue(hsv, i, light) {
  var value;

  if (light) {
    value = hsv.v + brightnessStep1 * i;
  } else {
    value = hsv.v - brightnessStep2 * i;
  }

  if (value > 1) {
    value = 1;
  }

  return Number(value.toFixed(2));
}

function generate(color) {
  var opts = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var patterns = [];
  var pColor = inputToRGB(color);

  for (var i = lightColorCount; i > 0; i -= 1) {
    var hsv = toHsv(pColor);
    var colorString = toHex(inputToRGB({
      h: getHue(hsv, i, true),
      s: getSaturation(hsv, i, true),
      v: getValue(hsv, i, true)
    }));
    patterns.push(colorString);
  }

  patterns.push(toHex(pColor));

  for (var _i = 1; _i <= darkColorCount; _i += 1) {
    var _hsv = toHsv(pColor);

    var _colorString = toHex(inputToRGB({
      h: getHue(_hsv, _i),
      s: getSaturation(_hsv, _i),
      v: getValue(_hsv, _i)
    }));

    patterns.push(_colorString);
  } // dark theme patterns


  if (opts.theme === 'dark') {
    return darkColorMap.map(function (_ref3) {
      var index = _ref3.index,
          opacity = _ref3.opacity;
      var darkColorString = toHex(mix(inputToRGB(opts.backgroundColor || '#141414'), inputToRGB(patterns[index]), opacity * 100));
      return darkColorString;
    });
  }

  return patterns;
}

var presetPrimaryColors = {
  red: '#F5222D',
  volcano: '#FA541C',
  orange: '#FA8C16',
  gold: '#FAAD14',
  yellow: '#FADB14',
  lime: '#A0D911',
  green: '#52C41A',
  cyan: '#13C2C2',
  blue: '#1677FF',
  geekblue: '#2F54EB',
  purple: '#722ED1',
  magenta: '#EB2F96',
  grey: '#666666'
};
var presetPalettes = {};
var presetDarkPalettes = {};
Object.keys(presetPrimaryColors).forEach(function (key) {
  presetPalettes[key] = generate(presetPrimaryColors[key]);
  presetPalettes[key].primary = presetPalettes[key][5]; // dark presetPalettes

  presetDarkPalettes[key] = generate(presetPrimaryColors[key], {
    theme: 'dark',
    backgroundColor: '#141414'
  });
  presetDarkPalettes[key].primary = presetDarkPalettes[key][5];
});
var blue = presetPalettes.blue;

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly && (symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    })), keys.push.apply(keys, symbols);
  }
  return keys;
}
function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = null != arguments[i] ? arguments[i] : {};
    i % 2 ? ownKeys(Object(source), !0).forEach(function (key) {
      _defineProperty(target, key, source[key]);
    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    });
  }
  return target;
}

/* eslint-disable no-console */
var warned = {};
var preWarningFns = [];

/**
 * Pre warning enable you to parse content before console.error.
 * Modify to null will prevent warning.
 */
var preMessage = function preMessage(fn) {
  preWarningFns.push(fn);
};
function warning(valid, message) {
  // Support uglify
  if (process.env.NODE_ENV !== 'production' && !valid && console !== undefined) {
    var finalMessage = preWarningFns.reduce(function (msg, preMessageFn) {
      return preMessageFn(msg !== null && msg !== void 0 ? msg : '', 'warning');
    }, message);
    if (finalMessage) {
      console.error("Warning: ".concat(finalMessage));
    }
  }
}
function note(valid, message) {
  // Support uglify
  if (process.env.NODE_ENV !== 'production' && !valid && console !== undefined) {
    var finalMessage = preWarningFns.reduce(function (msg, preMessageFn) {
      return preMessageFn(msg !== null && msg !== void 0 ? msg : '', 'note');
    }, message);
    if (finalMessage) {
      console.warn("Note: ".concat(finalMessage));
    }
  }
}
function resetWarned() {
  warned = {};
}
function call(method, valid, message) {
  if (!valid && !warned[message]) {
    method(false, message);
    warned[message] = true;
  }
}
function warningOnce(valid, message) {
  call(warning, valid, message);
}
function noteOnce(valid, message) {
  call(note, valid, message);
}
warningOnce.preMessage = preMessage;
warningOnce.resetWarned = resetWarned;
warningOnce.noteOnce = noteOnce;
/* eslint-enable */

function canUseDom() {
  return !!(typeof window !== 'undefined' && window.document && window.document.createElement);
}

function contains(root, n) {
  if (!root) {
    return false;
  }

  // Use native if support
  if (root.contains) {
    return root.contains(n);
  }

  // `document.contains` not support with IE11
  var node = n;
  while (node) {
    if (node === root) {
      return true;
    }
    node = node.parentNode;
  }
  return false;
}

var APPEND_ORDER = 'data-rc-order';
var MARK_KEY = "rc-util-key";
var containerCache = new Map();
function getMark() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
    mark = _ref.mark;
  if (mark) {
    return mark.startsWith('data-') ? mark : "data-".concat(mark);
  }
  return MARK_KEY;
}
function getContainer(option) {
  if (option.attachTo) {
    return option.attachTo;
  }
  var head = document.querySelector('head');
  return head || document.body;
}
function getOrder(prepend) {
  if (prepend === 'queue') {
    return 'prependQueue';
  }
  return prepend ? 'prepend' : 'append';
}

/**
 * Find style which inject by rc-util
 */
function findStyles(container) {
  return Array.from((containerCache.get(container) || container).children).filter(function (node) {
    return node.tagName === 'STYLE';
  });
}
function injectCSS(css) {
  var option = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  if (!canUseDom()) {
    return null;
  }
  var csp = option.csp,
    prepend = option.prepend;
  var styleNode = document.createElement('style');
  styleNode.setAttribute(APPEND_ORDER, getOrder(prepend));
  if (csp !== null && csp !== void 0 && csp.nonce) {
    styleNode.nonce = csp === null || csp === void 0 ? void 0 : csp.nonce;
  }
  styleNode.innerHTML = css;
  var container = getContainer(option);
  var firstChild = container.firstChild;
  if (prepend) {
    // If is queue `prepend`, it will prepend first style and then append rest style
    if (prepend === 'queue') {
      var existStyle = findStyles(container).filter(function (node) {
        return ['prepend', 'prependQueue'].includes(node.getAttribute(APPEND_ORDER));
      });
      if (existStyle.length) {
        container.insertBefore(styleNode, existStyle[existStyle.length - 1].nextSibling);
        return styleNode;
      }
    }

    // Use `insertBefore` as `prepend`
    container.insertBefore(styleNode, firstChild);
  } else {
    container.appendChild(styleNode);
  }
  return styleNode;
}
function findExistNode(key) {
  var option = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var container = getContainer(option);
  return findStyles(container).find(function (node) {
    return node.getAttribute(getMark(option)) === key;
  });
}

/**
 * qiankun will inject `appendChild` to insert into other
 */
function syncRealContainer(container, option) {
  var cachedRealContainer = containerCache.get(container);

  // Find real container when not cached or cached container removed
  if (!cachedRealContainer || !contains(document, cachedRealContainer)) {
    var placeholderStyle = injectCSS('', option);
    var parentNode = placeholderStyle.parentNode;
    containerCache.set(container, parentNode);
    container.removeChild(placeholderStyle);
  }
}
function updateCSS(css, key) {
  var option = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  var container = getContainer(option);

  // Sync real parent
  syncRealContainer(container, option);
  var existNode = findExistNode(key, option);
  if (existNode) {
    var _option$csp, _option$csp2;
    if ((_option$csp = option.csp) !== null && _option$csp !== void 0 && _option$csp.nonce && existNode.nonce !== ((_option$csp2 = option.csp) === null || _option$csp2 === void 0 ? void 0 : _option$csp2.nonce)) {
      var _option$csp3;
      existNode.nonce = (_option$csp3 = option.csp) === null || _option$csp3 === void 0 ? void 0 : _option$csp3.nonce;
    }
    if (existNode.innerHTML !== css) {
      existNode.innerHTML = css;
    }
    return existNode;
  }
  var newNode = injectCSS(css, option);
  newNode.setAttribute(getMark(option), key);
  return newNode;
}

function getRoot(ele) {
  var _ele$getRootNode;
  return ele === null || ele === void 0 ? void 0 : (_ele$getRootNode = ele.getRootNode) === null || _ele$getRootNode === void 0 ? void 0 : _ele$getRootNode.call(ele);
}

/**
 * Check if is in shadowRoot
 */
function inShadow(ele) {
  return getRoot(ele) !== (ele === null || ele === void 0 ? void 0 : ele.ownerDocument);
}

/**
 * Return shadowRoot if possible
 */
function getShadowRoot(ele) {
  return inShadow(ele) ? getRoot(ele) : null;
}

function warning$1(valid, message) {
  warningOnce(valid, "[@ant-design/icons] ".concat(message));
}
function isIconDefinition(target) {
  return _typeof(target) === 'object' && typeof target.name === 'string' && typeof target.theme === 'string' && (_typeof(target.icon) === 'object' || typeof target.icon === 'function');
}
function normalizeAttrs() {
  var attrs = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  return Object.keys(attrs).reduce(function (acc, key) {
    var val = attrs[key];
    switch (key) {
      case 'class':
        acc.className = val;
        delete acc.class;
        break;
      default:
        acc[key] = val;
    }
    return acc;
  }, {});
}
function generate$1(node, key, rootProps) {
  if (!rootProps) {
    return /*#__PURE__*/React__default.createElement(node.tag, _objectSpread2({
      key: key
    }, normalizeAttrs(node.attrs)), (node.children || []).map(function (child, index) {
      return generate$1(child, "".concat(key, "-").concat(node.tag, "-").concat(index));
    }));
  }
  return /*#__PURE__*/React__default.createElement(node.tag, _objectSpread2(_objectSpread2({
    key: key
  }, normalizeAttrs(node.attrs)), rootProps), (node.children || []).map(function (child, index) {
    return generate$1(child, "".concat(key, "-").concat(node.tag, "-").concat(index));
  }));
}
function getSecondaryColor(primaryColor) {
  // choose the second color
  return generate(primaryColor)[0];
}
function normalizeTwoToneColors(twoToneColor) {
  if (!twoToneColor) {
    return [];
  }
  return Array.isArray(twoToneColor) ? twoToneColor : [twoToneColor];
}
var iconStyles = "\n.anticon {\n  display: inline-block;\n  color: inherit;\n  font-style: normal;\n  line-height: 0;\n  text-align: center;\n  text-transform: none;\n  vertical-align: -0.125em;\n  text-rendering: optimizeLegibility;\n  -webkit-font-smoothing: antialiased;\n  -moz-osx-font-smoothing: grayscale;\n}\n\n.anticon > * {\n  line-height: 1;\n}\n\n.anticon svg {\n  display: inline-block;\n}\n\n.anticon::before {\n  display: none;\n}\n\n.anticon .anticon-icon {\n  display: block;\n}\n\n.anticon[tabindex] {\n  cursor: pointer;\n}\n\n.anticon-spin::before,\n.anticon-spin {\n  display: inline-block;\n  -webkit-animation: loadingCircle 1s infinite linear;\n  animation: loadingCircle 1s infinite linear;\n}\n\n@-webkit-keyframes loadingCircle {\n  100% {\n    -webkit-transform: rotate(360deg);\n    transform: rotate(360deg);\n  }\n}\n\n@keyframes loadingCircle {\n  100% {\n    -webkit-transform: rotate(360deg);\n    transform: rotate(360deg);\n  }\n}\n";
var useInsertStyles = function useInsertStyles(eleRef) {
  var _useContext = React.useContext(IconContext),
    csp = _useContext.csp,
    prefixCls = _useContext.prefixCls;
  var mergedStyleStr = iconStyles;
  if (prefixCls) {
    mergedStyleStr = mergedStyleStr.replace(/anticon/g, prefixCls);
  }
  React.useEffect(function () {
    var ele = eleRef.current;
    var shadowRoot = getShadowRoot(ele);
    updateCSS(mergedStyleStr, '@ant-design-icons', {
      prepend: true,
      csp: csp,
      attachTo: shadowRoot
    });
  }, []);
};

var _excluded = ["icon", "className", "onClick", "style", "primaryColor", "secondaryColor"];
var twoToneColorPalette = {
  primaryColor: '#333',
  secondaryColor: '#E6E6E6',
  calculated: false
};
function setTwoToneColors(_ref) {
  var primaryColor = _ref.primaryColor,
    secondaryColor = _ref.secondaryColor;
  twoToneColorPalette.primaryColor = primaryColor;
  twoToneColorPalette.secondaryColor = secondaryColor || getSecondaryColor(primaryColor);
  twoToneColorPalette.calculated = !!secondaryColor;
}
function getTwoToneColors() {
  return _objectSpread2({}, twoToneColorPalette);
}
var IconBase = function IconBase(props) {
  var icon = props.icon,
    className = props.className,
    onClick = props.onClick,
    style = props.style,
    primaryColor = props.primaryColor,
    secondaryColor = props.secondaryColor,
    restProps = _objectWithoutProperties(props, _excluded);
  var svgRef = React.useRef();
  var colors = twoToneColorPalette;
  if (primaryColor) {
    colors = {
      primaryColor: primaryColor,
      secondaryColor: secondaryColor || getSecondaryColor(primaryColor)
    };
  }
  useInsertStyles(svgRef);
  warning$1(isIconDefinition(icon), "icon should be icon definiton, but got ".concat(icon));
  if (!isIconDefinition(icon)) {
    return null;
  }
  var target = icon;
  if (target && typeof target.icon === 'function') {
    target = _objectSpread2(_objectSpread2({}, target), {}, {
      icon: target.icon(colors.primaryColor, colors.secondaryColor)
    });
  }
  return generate$1(target.icon, "svg-".concat(target.name), _objectSpread2(_objectSpread2({
    className: className,
    onClick: onClick,
    style: style,
    'data-icon': target.name,
    width: '1em',
    height: '1em',
    fill: 'currentColor',
    'aria-hidden': 'true'
  }, restProps), {}, {
    ref: svgRef
  }));
};
IconBase.displayName = 'IconReact';
IconBase.getTwoToneColors = getTwoToneColors;
IconBase.setTwoToneColors = setTwoToneColors;

function setTwoToneColor(twoToneColor) {
  var _normalizeTwoToneColo = normalizeTwoToneColors(twoToneColor),
    _normalizeTwoToneColo2 = _slicedToArray(_normalizeTwoToneColo, 2),
    primaryColor = _normalizeTwoToneColo2[0],
    secondaryColor = _normalizeTwoToneColo2[1];
  return IconBase.setTwoToneColors({
    primaryColor: primaryColor,
    secondaryColor: secondaryColor
  });
}
function getTwoToneColor() {
  var colors = IconBase.getTwoToneColors();
  if (!colors.calculated) {
    return colors.primaryColor;
  }
  return [colors.primaryColor, colors.secondaryColor];
}

var _excluded$1 = ["className", "icon", "spin", "rotate", "tabIndex", "onClick", "twoToneColor"];
// Initial setting
// should move it to antd main repo?
setTwoToneColor(blue.primary);

// https://github.com/DefinitelyTyped/DefinitelyTyped/issues/34757#issuecomment-488848720

var Icon = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var _classNames;
  var className = props.className,
    icon = props.icon,
    spin = props.spin,
    rotate = props.rotate,
    tabIndex = props.tabIndex,
    onClick = props.onClick,
    twoToneColor = props.twoToneColor,
    restProps = _objectWithoutProperties(props, _excluded$1);
  var _React$useContext = React.useContext(IconContext),
    _React$useContext$pre = _React$useContext.prefixCls,
    prefixCls = _React$useContext$pre === void 0 ? 'anticon' : _React$useContext$pre,
    rootClassName = _React$useContext.rootClassName;
  var classString = classnames(rootClassName, prefixCls, (_classNames = {}, _defineProperty(_classNames, "".concat(prefixCls, "-").concat(icon.name), !!icon.name), _defineProperty(_classNames, "".concat(prefixCls, "-spin"), !!spin || icon.name === 'loading'), _classNames), className);
  var iconTabIndex = tabIndex;
  if (iconTabIndex === undefined && onClick) {
    iconTabIndex = -1;
  }
  var svgStyle = rotate ? {
    msTransform: "rotate(".concat(rotate, "deg)"),
    transform: "rotate(".concat(rotate, "deg)")
  } : undefined;
  var _normalizeTwoToneColo = normalizeTwoToneColors(twoToneColor),
    _normalizeTwoToneColo2 = _slicedToArray(_normalizeTwoToneColo, 2),
    primaryColor = _normalizeTwoToneColo2[0],
    secondaryColor = _normalizeTwoToneColo2[1];
  return /*#__PURE__*/React.createElement("span", _extends$1({
    role: "img",
    "aria-label": icon.name
  }, restProps, {
    ref: ref,
    tabIndex: iconTabIndex,
    onClick: onClick,
    className: classString
  }), /*#__PURE__*/React.createElement(IconBase, {
    icon: icon,
    primaryColor: primaryColor,
    secondaryColor: secondaryColor,
    style: svgStyle
  }));
});
Icon.displayName = 'AntdIcon';
Icon.getTwoToneColor = getTwoToneColor;
Icon.setTwoToneColor = setTwoToneColor;

// This icon file is generated automatically.
var CloseOutlined = { "icon": { "tag": "svg", "attrs": { "viewBox": "64 64 896 896", "focusable": "false" }, "children": [{ "tag": "path", "attrs": { "d": "M563.8 512l262.5-312.9c4.4-5.2.7-13.1-6.1-13.1h-79.8c-4.7 0-9.2 2.1-12.3 5.7L511.6 449.8 295.1 191.7c-3-3.6-7.5-5.7-12.3-5.7H203c-6.8 0-10.5 7.9-6.1 13.1L459.4 512 196.9 824.9A7.95 7.95 0 00203 838h79.8c4.7 0 9.2-2.1 12.3-5.7l216.5-258.1 216.5 258.1c3 3.6 7.5 5.7 12.3 5.7h79.8c6.8 0 10.5-7.9 6.1-13.1L563.8 512z" } }] }, "name": "close", "theme": "outlined" };

var CloseOutlined$1 = function CloseOutlined$1(props, ref) {
  return /*#__PURE__*/React.createElement(Icon, _extends$1({}, props, {
    ref: ref,
    icon: CloseOutlined
  }));
};
if (process.env.NODE_ENV !== 'production') {
  CloseOutlined$1.displayName = 'CloseOutlined';
}
var CloseOutlined$2 = /*#__PURE__*/React.forwardRef(CloseOutlined$1);

// This icon file is generated automatically.
var FileImageOutlined = { "icon": { "tag": "svg", "attrs": { "viewBox": "64 64 896 896", "focusable": "false" }, "children": [{ "tag": "path", "attrs": { "d": "M553.1 509.1l-77.8 99.2-41.1-52.4a8 8 0 00-12.6 0l-99.8 127.2a7.98 7.98 0 006.3 12.9H696c6.7 0 10.4-7.7 6.3-12.9l-136.5-174a8.1 8.1 0 00-12.7 0zM360 442a40 40 0 1080 0 40 40 0 10-80 0zm494.6-153.4L639.4 73.4c-6-6-14.1-9.4-22.6-9.4H192c-17.7 0-32 14.3-32 32v832c0 17.7 14.3 32 32 32h640c17.7 0 32-14.3 32-32V311.3c0-8.5-3.4-16.7-9.4-22.7zM790.2 326H602V137.8L790.2 326zm1.8 562H232V136h302v216a42 42 0 0042 42h216v494z" } }] }, "name": "file-image", "theme": "outlined" };

var FileImageOutlined$1 = function FileImageOutlined$1(props, ref) {
  return /*#__PURE__*/React.createElement(Icon, _extends$1({}, props, {
    ref: ref,
    icon: FileImageOutlined
  }));
};
if (process.env.NODE_ENV !== 'production') {
  FileImageOutlined$1.displayName = 'FileImageOutlined';
}
var FileImageOutlined$2 = /*#__PURE__*/React.forwardRef(FileImageOutlined$1);

// This icon file is generated automatically.
var PaperClipOutlined = { "icon": { "tag": "svg", "attrs": { "viewBox": "64 64 896 896", "focusable": "false" }, "children": [{ "tag": "path", "attrs": { "d": "M779.3 196.6c-94.2-94.2-247.6-94.2-341.7 0l-261 260.8c-1.7 1.7-2.6 4-2.6 6.4s.9 4.7 2.6 6.4l36.9 36.9a9 9 0 0012.7 0l261-260.8c32.4-32.4 75.5-50.2 121.3-50.2s88.9 17.8 121.2 50.2c32.4 32.4 50.2 75.5 50.2 121.2 0 45.8-17.8 88.8-50.2 121.2l-266 265.9-43.1 43.1c-40.3 40.3-105.8 40.3-146.1 0-19.5-19.5-30.2-45.4-30.2-73s10.7-53.5 30.2-73l263.9-263.8c6.7-6.6 15.5-10.3 24.9-10.3h.1c9.4 0 18.1 3.7 24.7 10.3 6.7 6.7 10.3 15.5 10.3 24.9 0 9.3-3.7 18.1-10.3 24.7L372.4 653c-1.7 1.7-2.6 4-2.6 6.4s.9 4.7 2.6 6.4l36.9 36.9a9 9 0 0012.7 0l215.6-215.6c19.9-19.9 30.8-46.3 30.8-74.4s-11-54.6-30.8-74.4c-41.1-41.1-107.9-41-149 0L463 364 224.8 602.1A172.22 172.22 0 00174 724.8c0 46.3 18.1 89.8 50.8 122.5 33.9 33.8 78.3 50.7 122.7 50.7 44.4 0 88.8-16.9 122.6-50.7l309.2-309C824.8 492.7 850 432 850 367.5c.1-64.6-25.1-125.3-70.7-170.9z" } }] }, "name": "paper-clip", "theme": "outlined" };

var PaperClipOutlined$1 = function PaperClipOutlined$1(props, ref) {
  return /*#__PURE__*/React.createElement(Icon, _extends$1({}, props, {
    ref: ref,
    icon: PaperClipOutlined
  }));
};
if (process.env.NODE_ENV !== 'production') {
  PaperClipOutlined$1.displayName = 'PaperClipOutlined';
}
var PaperClipOutlined$2 = /*#__PURE__*/React.forwardRef(PaperClipOutlined$1);

// This icon file is generated automatically.
var SendOutlined = { "icon": { "tag": "svg", "attrs": { "viewBox": "64 64 896 896", "focusable": "false" }, "children": [{ "tag": "defs", "attrs": {}, "children": [{ "tag": "style", "attrs": {} }] }, { "tag": "path", "attrs": { "d": "M931.4 498.9L94.9 79.5c-3.4-1.7-7.3-2.1-11-1.2a15.99 15.99 0 00-11.7 19.3l86.2 352.2c1.3 5.3 5.2 9.6 10.4 11.3l147.7 50.7-147.6 50.7c-5.2 1.8-9.1 6-10.3 11.3L72.2 926.5c-.9 3.7-.5 7.6 1.2 10.9 3.9 7.9 13.5 11.1 21.5 7.2l836.5-417c3.1-1.5 5.6-4.1 7.2-7.1 3.9-8 .7-17.6-7.2-21.6zM170.8 826.3l50.3-205.6 295.2-101.3c2.3-.8 4.2-2.6 5-5 1.4-4.2-.8-8.7-5-10.2L221.1 403 171 198.2l628 314.9-628.2 313.2z" } }] }, "name": "send", "theme": "outlined" };

var SendOutlined$1 = function SendOutlined$1(props, ref) {
  return /*#__PURE__*/React.createElement(Icon, _extends$1({}, props, {
    ref: ref,
    icon: SendOutlined
  }));
};
if (process.env.NODE_ENV !== 'production') {
  SendOutlined$1.displayName = 'SendOutlined';
}
var SendOutlined$2 = /*#__PURE__*/React.forwardRef(SendOutlined$1);

// This icon file is generated automatically.
var WarningOutlined = { "icon": { "tag": "svg", "attrs": { "viewBox": "64 64 896 896", "focusable": "false" }, "children": [{ "tag": "path", "attrs": { "d": "M464 720a48 48 0 1096 0 48 48 0 10-96 0zm16-304v184c0 4.4 3.6 8 8 8h48c4.4 0 8-3.6 8-8V416c0-4.4-3.6-8-8-8h-48c-4.4 0-8 3.6-8 8zm475.7 440l-416-720c-6.2-10.7-16.9-16-27.7-16s-21.6 5.3-27.7 16l-416 720C56 877.4 71.4 904 96 904h832c24.6 0 40-26.6 27.7-48zm-783.5-27.9L512 239.9l339.8 588.2H172.2z" } }] }, "name": "warning", "theme": "outlined" };

var WarningOutlined$1 = function WarningOutlined$1(props, ref) {
  return /*#__PURE__*/React.createElement(Icon, _extends$1({}, props, {
    ref: ref,
    icon: WarningOutlined
  }));
};
if (process.env.NODE_ENV !== 'production') {
  WarningOutlined$1.displayName = 'WarningOutlined';
}
var WarningOutlined$2 = /*#__PURE__*/React.forwardRef(WarningOutlined$1);

var MessagesRender = React.forwardRef(function (props, ref) {
  var _props$messages = props.messages,
    messages = _props$messages === void 0 ? [] : _props$messages,
    _props$startReached = props.startReached,
    startReached = _props$startReached === void 0 ? function () {} : _props$startReached,
    _props$type = props.type,
    type = _props$type === void 0 ? CONST.CONVERSATION_TYPE.MESSENGER : _props$type,
    _props$messageStyle = props.messageStyle,
    messageStyle = _props$messageStyle === void 0 ? {} : _props$messageStyle;
  var _useState = React.useState(0),
    scrollBottom = _useState[0],
    setScrollBottom = _useState[1];
  React.useImperativeHandle(ref, function () {
    return {
      scrollToBottom: function scrollToBottom() {
        return _scrollToBottom();
      }
    };
  });
  var messagesRef = React.useRef(null);
  var bottomRef = React.useRef(null);
  React.useEffect(function () {
    _scrollToBottom();
  }, []);
  React.useEffect(function () {
    var _messagesRef$current;
    var scrollHeight = messagesRef === null || messagesRef === void 0 ? void 0 : (_messagesRef$current = messagesRef.current) === null || _messagesRef$current === void 0 ? void 0 : _messagesRef$current.scrollHeight;
    var top = scrollHeight - scrollBottom;
    scrollToPosition(top);
  }, [messages]);
  var _scrollToBottom = function _scrollToBottom(behavior) {
    var _bottomRef$current;
    if (behavior === void 0) {
      behavior = 'auto';
    }
    (_bottomRef$current = bottomRef.current) === null || _bottomRef$current === void 0 ? void 0 : _bottomRef$current.scrollIntoView({
      behavior: behavior
    });
  };
  var scrollToPosition = function scrollToPosition(top, behavior) {
    var _messagesRef$current2;
    if (behavior === void 0) {
      behavior = 'auto';
    }
    (_messagesRef$current2 = messagesRef.current) === null || _messagesRef$current2 === void 0 ? void 0 : _messagesRef$current2.scrollTo({
      top: top,
      behavior: behavior
    });
  };
  var handleScroll = function handleScroll(event) {
    var scrollTop = event.currentTarget.scrollTop;
    var scrollHeight = event.currentTarget.scrollHeight;
    var scrollBottom = scrollHeight - scrollTop;
    if (scrollTop < scrollHeight / 4) {
      setScrollBottom(scrollBottom);
      startReached();
    }
  };
  var renderTime = function renderTime(rowData, index, time_field) {
    if (time_field === void 0) {
      time_field = 'time';
    }
    var preRow = messages === null || messages === void 0 ? void 0 : messages[index - 1];
    if (!preRow || moment(rowData === null || rowData === void 0 ? void 0 : rowData[time_field]).diff(moment(preRow === null || preRow === void 0 ? void 0 : preRow[time_field]), 'minutes') > 30) {
      return /*#__PURE__*/React__default.createElement("div", {
        style: {
          textAlign: 'center',
          marginTop: 12,
          color: '#999',
          fontWeight: 400,
          fontSize: 12
        }
      }, moment(rowData === null || rowData === void 0 ? void 0 : rowData[time_field]).format('HH:mm, DD [tháng] MM, YYYY'));
    }
    return null;
  };
  var renderMessageZaloByType = function renderMessageZaloByType(rowData, index) {
    var _rowData$style, _rowData$style2, _rowData$style3, _rowData$style4, _rowData$style5;
    switch (rowData.type) {
      case 'text':
        return /*#__PURE__*/React__default.createElement("div", {
          key: index
        }, renderTime(rowData, index), /*#__PURE__*/React__default.createElement("div", {
          style: {
            display: 'flex',
            justifyContent: rowData === null || rowData === void 0 ? void 0 : (_rowData$style = rowData.style) === null || _rowData$style === void 0 ? void 0 : _rowData$style.justifyContent
          },
          key: rowData === null || rowData === void 0 ? void 0 : rowData.id
        }, /*#__PURE__*/React__default.createElement("div", {
          style: _extends({
            padding: '4px 8px',
            borderRadius: 12,
            whiteSpace: 'pre-wrap',
            overflowWrap: 'break-word',
            maxWidth: 320
          }, rowData === null || rowData === void 0 ? void 0 : rowData.style)
        }, "" + (rowData === null || rowData === void 0 ? void 0 : rowData.message))));
      case 'sticker':
        return /*#__PURE__*/React__default.createElement("div", {
          key: index
        }, renderTime(rowData, index), /*#__PURE__*/React__default.createElement("div", {
          style: {
            display: 'flex',
            justifyContent: rowData === null || rowData === void 0 ? void 0 : (_rowData$style2 = rowData.style) === null || _rowData$style2 === void 0 ? void 0 : _rowData$style2.justifyContent
          },
          key: rowData === null || rowData === void 0 ? void 0 : rowData.id
        }, /*#__PURE__*/React__default.createElement("img", {
          src: rowData === null || rowData === void 0 ? void 0 : rowData.url,
          style: {
            maxWidth: 100,
            margin: '6px 12px'
          }
        })));
      case 'photo':
        return /*#__PURE__*/React__default.createElement("div", {
          key: index
        }, renderTime(rowData, index), /*#__PURE__*/React__default.createElement("div", {
          style: {
            display: 'flex',
            justifyContent: rowData === null || rowData === void 0 ? void 0 : (_rowData$style3 = rowData.style) === null || _rowData$style3 === void 0 ? void 0 : _rowData$style3.justifyContent
          },
          key: rowData === null || rowData === void 0 ? void 0 : rowData.id
        }, /*#__PURE__*/React__default.createElement("img", {
          src: rowData === null || rowData === void 0 ? void 0 : rowData.url,
          style: {
            maxWidth: 300,
            margin: '6px 12px'
          }
        })));
      case 'gif':
        return /*#__PURE__*/React__default.createElement("div", {
          key: index
        }, renderTime(rowData, index), /*#__PURE__*/React__default.createElement("div", {
          style: {
            display: 'flex',
            justifyContent: rowData === null || rowData === void 0 ? void 0 : (_rowData$style4 = rowData.style) === null || _rowData$style4 === void 0 ? void 0 : _rowData$style4.justifyContent
          },
          key: rowData === null || rowData === void 0 ? void 0 : rowData.id
        }, /*#__PURE__*/React__default.createElement("img", {
          src: rowData === null || rowData === void 0 ? void 0 : rowData.url,
          style: {
            maxWidth: 300,
            margin: '6px 12px'
          }
        })));
      default:
        return /*#__PURE__*/React__default.createElement("div", {
          key: index
        }, renderTime(rowData, index), /*#__PURE__*/React__default.createElement("div", {
          style: {
            display: 'flex',
            justifyContent: rowData === null || rowData === void 0 ? void 0 : (_rowData$style5 = rowData.style) === null || _rowData$style5 === void 0 ? void 0 : _rowData$style5.justifyContent
          },
          key: rowData === null || rowData === void 0 ? void 0 : rowData.id
        }, /*#__PURE__*/React__default.createElement(antd.Space, {
          style: {
            margin: '6px 12px',
            color: '#888'
          }
        }, /*#__PURE__*/React__default.createElement(WarningOutlined$2, {
          style: {
            fontSize: 20
          }
        }), /*#__PURE__*/React__default.createElement("div", null, "N\u1ED9i dung kh\xF4ng h\u1ED7 tr\u1EE3"))));
    }
  };
  var renderMessageFacebookByType = function renderMessageFacebookByType(rowData, index) {
    var _rowData$style9;
    if (rowData !== null && rowData !== void 0 && rowData.message) {
      var _rowData$style6;
      return /*#__PURE__*/React__default.createElement("div", {
        key: index
      }, renderTime(rowData, index, 'created_time'), /*#__PURE__*/React__default.createElement("div", {
        style: {
          display: 'flex',
          justifyContent: rowData === null || rowData === void 0 ? void 0 : (_rowData$style6 = rowData.style) === null || _rowData$style6 === void 0 ? void 0 : _rowData$style6.justifyContent
        },
        key: rowData === null || rowData === void 0 ? void 0 : rowData.id
      }, /*#__PURE__*/React__default.createElement("div", {
        style: _extends({
          padding: '4px 8px',
          borderRadius: 12,
          whiteSpace: 'pre-wrap',
          overflowWrap: 'break-word',
          maxWidth: 320
        }, rowData === null || rowData === void 0 ? void 0 : rowData.style, messageStyle)
      }, "" + (rowData === null || rowData === void 0 ? void 0 : rowData.message))));
    } else if (rowData !== null && rowData !== void 0 && rowData.sticker) {
      var _rowData$style7;
      return /*#__PURE__*/React__default.createElement("div", {
        key: index
      }, renderTime(rowData, index, 'created_time'), /*#__PURE__*/React__default.createElement("div", {
        style: {
          display: 'flex',
          justifyContent: rowData === null || rowData === void 0 ? void 0 : (_rowData$style7 = rowData.style) === null || _rowData$style7 === void 0 ? void 0 : _rowData$style7.justifyContent
        },
        key: rowData === null || rowData === void 0 ? void 0 : rowData.id
      }, /*#__PURE__*/React__default.createElement("div", {
        style: {
          padding: '4px 8px',
          maxWidth: 160
        }
      }, /*#__PURE__*/React__default.createElement("img", {
        src: rowData === null || rowData === void 0 ? void 0 : rowData.sticker,
        style: {
          maxWidth: 160
        }
      }))));
    } else if (rowData !== null && rowData !== void 0 && rowData.attachments) {
      var _rowData$style8, _rowData$attachments, _rowData$attachments$, _rowData$attachments2, _rowData$attachments3, _rowData$attachments4, _rowData$attachments5, _rowData$attachments6, _rowData$attachments7, _rowData$attachments8, _rowData$attachments9, _rowData$attachments10, _rowData$attachments11;
      return /*#__PURE__*/React__default.createElement("div", {
        key: index
      }, renderTime(rowData, index, 'created_time'), /*#__PURE__*/React__default.createElement("div", {
        style: {
          display: 'flex',
          justifyContent: rowData === null || rowData === void 0 ? void 0 : (_rowData$style8 = rowData.style) === null || _rowData$style8 === void 0 ? void 0 : _rowData$style8.justifyContent
        },
        key: rowData === null || rowData === void 0 ? void 0 : rowData.id
      }, (rowData === null || rowData === void 0 ? void 0 : (_rowData$attachments = rowData.attachments) === null || _rowData$attachments === void 0 ? void 0 : (_rowData$attachments$ = _rowData$attachments.data) === null || _rowData$attachments$ === void 0 ? void 0 : _rowData$attachments$.length) > 1 ? /*#__PURE__*/React__default.createElement("div", {
        style: _extends({
          padding: '4px 8px'
        }, rowData === null || rowData === void 0 ? void 0 : rowData.style, {
          margin: 0,
          backgroundColor: 'transparent',
          maxWidth: 320,
          display: 'flex',
          flexDirection: 'row'
        }, messageStyle)
      }, rowData === null || rowData === void 0 ? void 0 : (_rowData$attachments2 = rowData.attachments) === null || _rowData$attachments2 === void 0 ? void 0 : (_rowData$attachments3 = _rowData$attachments2.data) === null || _rowData$attachments3 === void 0 ? void 0 : _rowData$attachments3.map(function (e) {
        var _e$image_data, _e$image_data2;
        return /*#__PURE__*/React__default.createElement(antd.Image, {
          preview: {
            src: e === null || e === void 0 ? void 0 : (_e$image_data = e.image_data) === null || _e$image_data === void 0 ? void 0 : _e$image_data.url
          },
          src: e === null || e === void 0 ? void 0 : (_e$image_data2 = e.image_data) === null || _e$image_data2 === void 0 ? void 0 : _e$image_data2.preview_url,
          style: {
            width: 100,
            height: 100,
            marginRight: 4,
            objectFit: 'cover'
          }
        });
      })) : /*#__PURE__*/React__default.createElement("div", {
        style: _extends({
          padding: '4px 8px'
        }, rowData === null || rowData === void 0 ? void 0 : rowData.style, {
          margin: 0,
          backgroundColor: 'transparent'
        }, messageStyle)
      }, /*#__PURE__*/React__default.createElement(antd.Image, {
        preview: {
          src: rowData === null || rowData === void 0 ? void 0 : (_rowData$attachments4 = rowData.attachments) === null || _rowData$attachments4 === void 0 ? void 0 : (_rowData$attachments5 = _rowData$attachments4.data) === null || _rowData$attachments5 === void 0 ? void 0 : (_rowData$attachments6 = _rowData$attachments5[0]) === null || _rowData$attachments6 === void 0 ? void 0 : (_rowData$attachments7 = _rowData$attachments6.image_data) === null || _rowData$attachments7 === void 0 ? void 0 : _rowData$attachments7.url
        },
        src: rowData === null || rowData === void 0 ? void 0 : (_rowData$attachments8 = rowData.attachments) === null || _rowData$attachments8 === void 0 ? void 0 : (_rowData$attachments9 = _rowData$attachments8.data) === null || _rowData$attachments9 === void 0 ? void 0 : (_rowData$attachments10 = _rowData$attachments9[0]) === null || _rowData$attachments10 === void 0 ? void 0 : (_rowData$attachments11 = _rowData$attachments10.image_data) === null || _rowData$attachments11 === void 0 ? void 0 : _rowData$attachments11.preview_url,
        style: {
          maxWidth: 160
        }
      }))));
    }
    return /*#__PURE__*/React__default.createElement("div", {
      key: index
    }, renderTime(rowData, index), /*#__PURE__*/React__default.createElement("div", {
      style: {
        display: 'flex',
        justifyContent: rowData === null || rowData === void 0 ? void 0 : (_rowData$style9 = rowData.style) === null || _rowData$style9 === void 0 ? void 0 : _rowData$style9.justifyContent
      },
      key: rowData === null || rowData === void 0 ? void 0 : rowData.id
    }, /*#__PURE__*/React__default.createElement(antd.Space, {
      style: {
        margin: '6px 12px',
        color: '#888'
      }
    }, /*#__PURE__*/React__default.createElement(WarningOutlined$2, {
      style: {
        fontSize: 20
      }
    }), /*#__PURE__*/React__default.createElement("div", null, "N\u1ED9i dung kh\xF4ng h\u1ED7 tr\u1EE3"))));
  };
  return /*#__PURE__*/React__default.createElement("div", {
    style: {
      flex: 1,
      overflowY: 'auto'
    },
    onScroll: handleScroll,
    ref: messagesRef
  }, /*#__PURE__*/React__default.createElement("div", {
    style: {
      display: 'flex',
      flexFlow: 'column',
      height: '100%',
      width: '100%'
    }
  }, type === CONST.CONVERSATION_TYPE.ZALO ? messages.map(function (e, i) {
    return renderMessageZaloByType(e, i);
  }) : messages.map(function (e, i) {
    return renderMessageFacebookByType(e, i);
  }), /*#__PURE__*/React__default.createElement("div", {
    ref: bottomRef
  })));
});

function bind(fn, thisArg) {
  return function wrap() {
    return fn.apply(thisArg, arguments);
  };
}

var toString = Object.prototype.toString;
var getPrototypeOf = Object.getPrototypeOf;
var kindOf = function (cache) {
  return function (thing) {
    var str = toString.call(thing);
    return cache[str] || (cache[str] = str.slice(8, -1).toLowerCase());
  };
}(Object.create(null));
var kindOfTest = function kindOfTest(type) {
  type = type.toLowerCase();
  return function (thing) {
    return kindOf(thing) === type;
  };
};
var typeOfTest = function typeOfTest(type) {
  return function (thing) {
    return typeof thing === type;
  };
};
var isArray = Array.isArray;
var isUndefined = typeOfTest('undefined');
function isBuffer(val) {
  return val !== null && !isUndefined(val) && val.constructor !== null && !isUndefined(val.constructor) && isFunction(val.constructor.isBuffer) && val.constructor.isBuffer(val);
}
var isArrayBuffer = kindOfTest('ArrayBuffer');
function isArrayBufferView(val) {
  var result;
  if (typeof ArrayBuffer !== 'undefined' && ArrayBuffer.isView) {
    result = ArrayBuffer.isView(val);
  } else {
    result = val && val.buffer && isArrayBuffer(val.buffer);
  }
  return result;
}
var isString = typeOfTest('string');
var isFunction = typeOfTest('function');
var isNumber = typeOfTest('number');
var isObject = function isObject(thing) {
  return thing !== null && typeof thing === 'object';
};
var isBoolean = function isBoolean(thing) {
  return thing === true || thing === false;
};
var isPlainObject = function isPlainObject(val) {
  if (kindOf(val) !== 'object') {
    return false;
  }
  var prototype = getPrototypeOf(val);
  return (prototype === null || prototype === Object.prototype || Object.getPrototypeOf(prototype) === null) && !(Symbol.toStringTag in val) && !(Symbol.iterator in val);
};
var isDate = kindOfTest('Date');
var isFile = kindOfTest('File');
var isBlob = kindOfTest('Blob');
var isFileList = kindOfTest('FileList');
var isStream = function isStream(val) {
  return isObject(val) && isFunction(val.pipe);
};
var isFormData = function isFormData(thing) {
  var kind;
  return thing && (typeof FormData === 'function' && thing instanceof FormData || isFunction(thing.append) && ((kind = kindOf(thing)) === 'formdata' || kind === 'object' && isFunction(thing.toString) && thing.toString() === '[object FormData]'));
};
var isURLSearchParams = kindOfTest('URLSearchParams');
var trim = function trim(str) {
  return str.trim ? str.trim() : str.replace(/^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g, '');
};
function forEach(obj, fn, _temp) {
  var _ref = _temp === void 0 ? {} : _temp,
    _ref$allOwnKeys = _ref.allOwnKeys,
    allOwnKeys = _ref$allOwnKeys === void 0 ? false : _ref$allOwnKeys;
  if (obj === null || typeof obj === 'undefined') {
    return;
  }
  var i;
  var l;
  if (typeof obj !== 'object') {
    obj = [obj];
  }
  if (isArray(obj)) {
    for (i = 0, l = obj.length; i < l; i++) {
      fn.call(null, obj[i], i, obj);
    }
  } else {
    var keys = allOwnKeys ? Object.getOwnPropertyNames(obj) : Object.keys(obj);
    var len = keys.length;
    var key;
    for (i = 0; i < len; i++) {
      key = keys[i];
      fn.call(null, obj[key], key, obj);
    }
  }
}
function findKey(obj, key) {
  key = key.toLowerCase();
  var keys = Object.keys(obj);
  var i = keys.length;
  var _key;
  while (i-- > 0) {
    _key = keys[i];
    if (key === _key.toLowerCase()) {
      return _key;
    }
  }
  return null;
}
var _global = function () {
  if (typeof globalThis !== "undefined") return globalThis;
  return typeof self !== "undefined" ? self : typeof window !== 'undefined' ? window : global;
}();
var isContextDefined = function isContextDefined(context) {
  return !isUndefined(context) && context !== _global;
};
function merge() {
  var _ref2 = isContextDefined(this) && this || {},
    caseless = _ref2.caseless;
  var result = {};
  var assignValue = function assignValue(val, key) {
    var targetKey = caseless && findKey(result, key) || key;
    if (isPlainObject(result[targetKey]) && isPlainObject(val)) {
      result[targetKey] = merge(result[targetKey], val);
    } else if (isPlainObject(val)) {
      result[targetKey] = merge({}, val);
    } else if (isArray(val)) {
      result[targetKey] = val.slice();
    } else {
      result[targetKey] = val;
    }
  };
  for (var i = 0, l = arguments.length; i < l; i++) {
    arguments[i] && forEach(arguments[i], assignValue);
  }
  return result;
}
var extend = function extend(a, b, thisArg, _temp2) {
  var _ref3 = _temp2 === void 0 ? {} : _temp2,
    allOwnKeys = _ref3.allOwnKeys;
  forEach(b, function (val, key) {
    if (thisArg && isFunction(val)) {
      a[key] = bind(val, thisArg);
    } else {
      a[key] = val;
    }
  }, {
    allOwnKeys: allOwnKeys
  });
  return a;
};
var stripBOM = function stripBOM(content) {
  if (content.charCodeAt(0) === 0xFEFF) {
    content = content.slice(1);
  }
  return content;
};
var inherits = function inherits(constructor, superConstructor, props, descriptors) {
  constructor.prototype = Object.create(superConstructor.prototype, descriptors);
  constructor.prototype.constructor = constructor;
  Object.defineProperty(constructor, 'super', {
    value: superConstructor.prototype
  });
  props && Object.assign(constructor.prototype, props);
};
var toFlatObject = function toFlatObject(sourceObj, destObj, filter, propFilter) {
  var props;
  var i;
  var prop;
  var merged = {};
  destObj = destObj || {};
  if (sourceObj == null) return destObj;
  do {
    props = Object.getOwnPropertyNames(sourceObj);
    i = props.length;
    while (i-- > 0) {
      prop = props[i];
      if ((!propFilter || propFilter(prop, sourceObj, destObj)) && !merged[prop]) {
        destObj[prop] = sourceObj[prop];
        merged[prop] = true;
      }
    }
    sourceObj = filter !== false && getPrototypeOf(sourceObj);
  } while (sourceObj && (!filter || filter(sourceObj, destObj)) && sourceObj !== Object.prototype);
  return destObj;
};
var endsWith = function endsWith(str, searchString, position) {
  str = String(str);
  if (position === undefined || position > str.length) {
    position = str.length;
  }
  position -= searchString.length;
  var lastIndex = str.indexOf(searchString, position);
  return lastIndex !== -1 && lastIndex === position;
};
var toArray = function toArray(thing) {
  if (!thing) return null;
  if (isArray(thing)) return thing;
  var i = thing.length;
  if (!isNumber(i)) return null;
  var arr = new Array(i);
  while (i-- > 0) {
    arr[i] = thing[i];
  }
  return arr;
};
var isTypedArray = function (TypedArray) {
  return function (thing) {
    return TypedArray && thing instanceof TypedArray;
  };
}(typeof Uint8Array !== 'undefined' && getPrototypeOf(Uint8Array));
var forEachEntry = function forEachEntry(obj, fn) {
  var generator = obj && obj[Symbol.iterator];
  var iterator = generator.call(obj);
  var result;
  while ((result = iterator.next()) && !result.done) {
    var pair = result.value;
    fn.call(obj, pair[0], pair[1]);
  }
};
var matchAll = function matchAll(regExp, str) {
  var matches;
  var arr = [];
  while ((matches = regExp.exec(str)) !== null) {
    arr.push(matches);
  }
  return arr;
};
var isHTMLForm = kindOfTest('HTMLFormElement');
var toCamelCase = function toCamelCase(str) {
  return str.toLowerCase().replace(/[-_\s]([a-z\d])(\w*)/g, function replacer(m, p1, p2) {
    return p1.toUpperCase() + p2;
  });
};
var hasOwnProperty = function (_ref4) {
  var hasOwnProperty = _ref4.hasOwnProperty;
  return function (obj, prop) {
    return hasOwnProperty.call(obj, prop);
  };
}(Object.prototype);
var isRegExp = kindOfTest('RegExp');
var reduceDescriptors = function reduceDescriptors(obj, reducer) {
  var descriptors = Object.getOwnPropertyDescriptors(obj);
  var reducedDescriptors = {};
  forEach(descriptors, function (descriptor, name) {
    if (reducer(descriptor, name, obj) !== false) {
      reducedDescriptors[name] = descriptor;
    }
  });
  Object.defineProperties(obj, reducedDescriptors);
};
var freezeMethods = function freezeMethods(obj) {
  reduceDescriptors(obj, function (descriptor, name) {
    if (isFunction(obj) && ['arguments', 'caller', 'callee'].indexOf(name) !== -1) {
      return false;
    }
    var value = obj[name];
    if (!isFunction(value)) return;
    descriptor.enumerable = false;
    if ('writable' in descriptor) {
      descriptor.writable = false;
      return;
    }
    if (!descriptor.set) {
      descriptor.set = function () {
        throw Error('Can not rewrite read-only method \'' + name + '\'');
      };
    }
  });
};
var toObjectSet = function toObjectSet(arrayOrString, delimiter) {
  var obj = {};
  var define = function define(arr) {
    arr.forEach(function (value) {
      obj[value] = true;
    });
  };
  isArray(arrayOrString) ? define(arrayOrString) : define(String(arrayOrString).split(delimiter));
  return obj;
};
var noop = function noop() {};
var toFiniteNumber = function toFiniteNumber(value, defaultValue) {
  value = +value;
  return Number.isFinite(value) ? value : defaultValue;
};
var ALPHA = 'abcdefghijklmnopqrstuvwxyz';
var DIGIT = '0123456789';
var ALPHABET = {
  DIGIT: DIGIT,
  ALPHA: ALPHA,
  ALPHA_DIGIT: ALPHA + ALPHA.toUpperCase() + DIGIT
};
var generateString = function generateString(size, alphabet) {
  if (size === void 0) {
    size = 16;
  }
  if (alphabet === void 0) {
    alphabet = ALPHABET.ALPHA_DIGIT;
  }
  var str = '';
  var _alphabet = alphabet,
    length = _alphabet.length;
  while (size--) {
    str += alphabet[Math.random() * length | 0];
  }
  return str;
};
function isSpecCompliantForm(thing) {
  return !!(thing && isFunction(thing.append) && thing[Symbol.toStringTag] === 'FormData' && thing[Symbol.iterator]);
}
var toJSONObject = function toJSONObject(obj) {
  var stack = new Array(10);
  var visit = function visit(source, i) {
    if (isObject(source)) {
      if (stack.indexOf(source) >= 0) {
        return;
      }
      if (!('toJSON' in source)) {
        stack[i] = source;
        var target = isArray(source) ? [] : {};
        forEach(source, function (value, key) {
          var reducedValue = visit(value, i + 1);
          !isUndefined(reducedValue) && (target[key] = reducedValue);
        });
        stack[i] = undefined;
        return target;
      }
    }
    return source;
  };
  return visit(obj, 0);
};
var isAsyncFn = kindOfTest('AsyncFunction');
var isThenable = function isThenable(thing) {
  return thing && (isObject(thing) || isFunction(thing)) && isFunction(thing.then) && isFunction(thing["catch"]);
};
var utils = {
  isArray: isArray,
  isArrayBuffer: isArrayBuffer,
  isBuffer: isBuffer,
  isFormData: isFormData,
  isArrayBufferView: isArrayBufferView,
  isString: isString,
  isNumber: isNumber,
  isBoolean: isBoolean,
  isObject: isObject,
  isPlainObject: isPlainObject,
  isUndefined: isUndefined,
  isDate: isDate,
  isFile: isFile,
  isBlob: isBlob,
  isRegExp: isRegExp,
  isFunction: isFunction,
  isStream: isStream,
  isURLSearchParams: isURLSearchParams,
  isTypedArray: isTypedArray,
  isFileList: isFileList,
  forEach: forEach,
  merge: merge,
  extend: extend,
  trim: trim,
  stripBOM: stripBOM,
  inherits: inherits,
  toFlatObject: toFlatObject,
  kindOf: kindOf,
  kindOfTest: kindOfTest,
  endsWith: endsWith,
  toArray: toArray,
  forEachEntry: forEachEntry,
  matchAll: matchAll,
  isHTMLForm: isHTMLForm,
  hasOwnProperty: hasOwnProperty,
  hasOwnProp: hasOwnProperty,
  reduceDescriptors: reduceDescriptors,
  freezeMethods: freezeMethods,
  toObjectSet: toObjectSet,
  toCamelCase: toCamelCase,
  noop: noop,
  toFiniteNumber: toFiniteNumber,
  findKey: findKey,
  global: _global,
  isContextDefined: isContextDefined,
  ALPHABET: ALPHABET,
  generateString: generateString,
  isSpecCompliantForm: isSpecCompliantForm,
  toJSONObject: toJSONObject,
  isAsyncFn: isAsyncFn,
  isThenable: isThenable
};

function AxiosError(message, code, config, request, response) {
  Error.call(this);
  if (Error.captureStackTrace) {
    Error.captureStackTrace(this, this.constructor);
  } else {
    this.stack = new Error().stack;
  }
  this.message = message;
  this.name = 'AxiosError';
  code && (this.code = code);
  config && (this.config = config);
  request && (this.request = request);
  response && (this.response = response);
}
utils.inherits(AxiosError, Error, {
  toJSON: function toJSON() {
    return {
      message: this.message,
      name: this.name,
      description: this.description,
      number: this.number,
      fileName: this.fileName,
      lineNumber: this.lineNumber,
      columnNumber: this.columnNumber,
      stack: this.stack,
      config: utils.toJSONObject(this.config),
      code: this.code,
      status: this.response && this.response.status ? this.response.status : null
    };
  }
});
var prototype = AxiosError.prototype;
var descriptors = {};
['ERR_BAD_OPTION_VALUE', 'ERR_BAD_OPTION', 'ECONNABORTED', 'ETIMEDOUT', 'ERR_NETWORK', 'ERR_FR_TOO_MANY_REDIRECTS', 'ERR_DEPRECATED', 'ERR_BAD_RESPONSE', 'ERR_BAD_REQUEST', 'ERR_CANCELED', 'ERR_NOT_SUPPORT', 'ERR_INVALID_URL'].forEach(function (code) {
  descriptors[code] = {
    value: code
  };
});
Object.defineProperties(AxiosError, descriptors);
Object.defineProperty(prototype, 'isAxiosError', {
  value: true
});
AxiosError.from = function (error, code, config, request, response, customProps) {
  var axiosError = Object.create(prototype);
  utils.toFlatObject(error, axiosError, function filter(obj) {
    return obj !== Error.prototype;
  }, function (prop) {
    return prop !== 'isAxiosError';
  });
  AxiosError.call(axiosError, error.message, code, config, request, response);
  axiosError.cause = error;
  axiosError.name = error.name;
  customProps && Object.assign(axiosError, customProps);
  return axiosError;
};

var httpAdapter = null;

function isVisitable(thing) {
  return utils.isPlainObject(thing) || utils.isArray(thing);
}
function removeBrackets(key) {
  return utils.endsWith(key, '[]') ? key.slice(0, -2) : key;
}
function renderKey(path, key, dots) {
  if (!path) return key;
  return path.concat(key).map(function each(token, i) {
    token = removeBrackets(token);
    return !dots && i ? '[' + token + ']' : token;
  }).join(dots ? '.' : '');
}
function isFlatArray(arr) {
  return utils.isArray(arr) && !arr.some(isVisitable);
}
var predicates = utils.toFlatObject(utils, {}, null, function filter(prop) {
  return /^is[A-Z]/.test(prop);
});
function toFormData(obj, formData, options) {
  if (!utils.isObject(obj)) {
    throw new TypeError('target must be an object');
  }
  formData = formData || new ( FormData)();
  options = utils.toFlatObject(options, {
    metaTokens: true,
    dots: false,
    indexes: false
  }, false, function defined(option, source) {
    return !utils.isUndefined(source[option]);
  });
  var metaTokens = options.metaTokens;
  var visitor = options.visitor || defaultVisitor;
  var dots = options.dots;
  var indexes = options.indexes;
  var _Blob = options.Blob || typeof Blob !== 'undefined' && Blob;
  var useBlob = _Blob && utils.isSpecCompliantForm(formData);
  if (!utils.isFunction(visitor)) {
    throw new TypeError('visitor must be a function');
  }
  function convertValue(value) {
    if (value === null) return '';
    if (utils.isDate(value)) {
      return value.toISOString();
    }
    if (!useBlob && utils.isBlob(value)) {
      throw new AxiosError('Blob is not supported. Use a Buffer instead.');
    }
    if (utils.isArrayBuffer(value) || utils.isTypedArray(value)) {
      return useBlob && typeof Blob === 'function' ? new Blob([value]) : Buffer.from(value);
    }
    return value;
  }
  function defaultVisitor(value, key, path) {
    var arr = value;
    if (value && !path && typeof value === 'object') {
      if (utils.endsWith(key, '{}')) {
        key = metaTokens ? key : key.slice(0, -2);
        value = JSON.stringify(value);
      } else if (utils.isArray(value) && isFlatArray(value) || (utils.isFileList(value) || utils.endsWith(key, '[]')) && (arr = utils.toArray(value))) {
        key = removeBrackets(key);
        arr.forEach(function each(el, index) {
          !(utils.isUndefined(el) || el === null) && formData.append(indexes === true ? renderKey([key], index, dots) : indexes === null ? key : key + '[]', convertValue(el));
        });
        return false;
      }
    }
    if (isVisitable(value)) {
      return true;
    }
    formData.append(renderKey(path, key, dots), convertValue(value));
    return false;
  }
  var stack = [];
  var exposedHelpers = Object.assign(predicates, {
    defaultVisitor: defaultVisitor,
    convertValue: convertValue,
    isVisitable: isVisitable
  });
  function build(value, path) {
    if (utils.isUndefined(value)) return;
    if (stack.indexOf(value) !== -1) {
      throw Error('Circular reference detected in ' + path.join('.'));
    }
    stack.push(value);
    utils.forEach(value, function each(el, key) {
      var result = !(utils.isUndefined(el) || el === null) && visitor.call(formData, el, utils.isString(key) ? key.trim() : key, path, exposedHelpers);
      if (result === true) {
        build(el, path ? path.concat(key) : [key]);
      }
    });
    stack.pop();
  }
  if (!utils.isObject(obj)) {
    throw new TypeError('data must be an object');
  }
  build(obj);
  return formData;
}

function encode(str) {
  var charMap = {
    '!': '%21',
    "'": '%27',
    '(': '%28',
    ')': '%29',
    '~': '%7E',
    '%20': '+',
    '%00': '\x00'
  };
  return encodeURIComponent(str).replace(/[!'()~]|%20|%00/g, function replacer(match) {
    return charMap[match];
  });
}
function AxiosURLSearchParams(params, options) {
  this._pairs = [];
  params && toFormData(params, this, options);
}
var prototype$1 = AxiosURLSearchParams.prototype;
prototype$1.append = function append(name, value) {
  this._pairs.push([name, value]);
};
prototype$1.toString = function toString(encoder) {
  var _encode = encoder ? function (value) {
    return encoder.call(this, value, encode);
  } : encode;
  return this._pairs.map(function each(pair) {
    return _encode(pair[0]) + '=' + _encode(pair[1]);
  }, '').join('&');
};

function encode$1(val) {
  return encodeURIComponent(val).replace(/%3A/gi, ':').replace(/%24/g, '$').replace(/%2C/gi, ',').replace(/%20/g, '+').replace(/%5B/gi, '[').replace(/%5D/gi, ']');
}
function buildURL(url, params, options) {
  if (!params) {
    return url;
  }
  var _encode = options && options.encode || encode$1;
  var serializeFn = options && options.serialize;
  var serializedParams;
  if (serializeFn) {
    serializedParams = serializeFn(params, options);
  } else {
    serializedParams = utils.isURLSearchParams(params) ? params.toString() : new AxiosURLSearchParams(params, options).toString(_encode);
  }
  if (serializedParams) {
    var hashmarkIndex = url.indexOf("#");
    if (hashmarkIndex !== -1) {
      url = url.slice(0, hashmarkIndex);
    }
    url += (url.indexOf('?') === -1 ? '?' : '&') + serializedParams;
  }
  return url;
}

var InterceptorManager = /*#__PURE__*/function () {
  function InterceptorManager() {
    this.handlers = [];
  }
  var _proto = InterceptorManager.prototype;
  _proto.use = function use(fulfilled, rejected, options) {
    this.handlers.push({
      fulfilled: fulfilled,
      rejected: rejected,
      synchronous: options ? options.synchronous : false,
      runWhen: options ? options.runWhen : null
    });
    return this.handlers.length - 1;
  };
  _proto.eject = function eject(id) {
    if (this.handlers[id]) {
      this.handlers[id] = null;
    }
  };
  _proto.clear = function clear() {
    if (this.handlers) {
      this.handlers = [];
    }
  };
  _proto.forEach = function forEach(fn) {
    utils.forEach(this.handlers, function forEachHandler(h) {
      if (h !== null) {
        fn(h);
      }
    });
  };
  return InterceptorManager;
}();

var transitionalDefaults = {
  silentJSONParsing: true,
  forcedJSONParsing: true,
  clarifyTimeoutError: false
};

var URLSearchParams$1 = typeof URLSearchParams !== 'undefined' ? URLSearchParams : AxiosURLSearchParams;

var FormData$1 = typeof FormData !== 'undefined' ? FormData : null;

var Blob$1 = typeof Blob !== 'undefined' ? Blob : null;

var isStandardBrowserEnv = function () {
  var product;
  if (typeof navigator !== 'undefined' && ((product = navigator.product) === 'ReactNative' || product === 'NativeScript' || product === 'NS')) {
    return false;
  }
  return typeof window !== 'undefined' && typeof document !== 'undefined';
}();
var isStandardBrowserWebWorkerEnv = function () {
  return typeof WorkerGlobalScope !== 'undefined' && self instanceof WorkerGlobalScope && typeof self.importScripts === 'function';
}();
var platform = {
  isBrowser: true,
  classes: {
    URLSearchParams: URLSearchParams$1,
    FormData: FormData$1,
    Blob: Blob$1
  },
  isStandardBrowserEnv: isStandardBrowserEnv,
  isStandardBrowserWebWorkerEnv: isStandardBrowserWebWorkerEnv,
  protocols: ['http', 'https', 'file', 'blob', 'url', 'data']
};

function toURLEncodedForm(data, options) {
  return toFormData(data, new platform.classes.URLSearchParams(), Object.assign({
    visitor: function visitor(value, key, path, helpers) {
      return helpers.defaultVisitor.apply(this, arguments);
    }
  }, options));
}

function parsePropPath(name) {
  return utils.matchAll(/\w+|\[(\w*)]/g, name).map(function (match) {
    return match[0] === '[]' ? '' : match[1] || match[0];
  });
}
function arrayToObject(arr) {
  var obj = {};
  var keys = Object.keys(arr);
  var i;
  var len = keys.length;
  var key;
  for (i = 0; i < len; i++) {
    key = keys[i];
    obj[key] = arr[key];
  }
  return obj;
}
function formDataToJSON(formData) {
  function buildPath(path, value, target, index) {
    var name = path[index++];
    var isNumericKey = Number.isFinite(+name);
    var isLast = index >= path.length;
    name = !name && utils.isArray(target) ? target.length : name;
    if (isLast) {
      if (utils.hasOwnProp(target, name)) {
        target[name] = [target[name], value];
      } else {
        target[name] = value;
      }
      return !isNumericKey;
    }
    if (!target[name] || !utils.isObject(target[name])) {
      target[name] = [];
    }
    var result = buildPath(path, value, target[name], index);
    if (result && utils.isArray(target[name])) {
      target[name] = arrayToObject(target[name]);
    }
    return !isNumericKey;
  }
  if (utils.isFormData(formData) && utils.isFunction(formData.entries)) {
    var obj = {};
    utils.forEachEntry(formData, function (name, value) {
      buildPath(parsePropPath(name), value, obj, 0);
    });
    return obj;
  }
  return null;
}

var DEFAULT_CONTENT_TYPE = {
  'Content-Type': undefined
};
function stringifySafely(rawValue, parser, encoder) {
  if (utils.isString(rawValue)) {
    try {
      (parser || JSON.parse)(rawValue);
      return utils.trim(rawValue);
    } catch (e) {
      if (e.name !== 'SyntaxError') {
        throw e;
      }
    }
  }
  return (encoder || JSON.stringify)(rawValue);
}
var defaults = {
  transitional: transitionalDefaults,
  adapter: ['xhr', 'http'],
  transformRequest: [function transformRequest(data, headers) {
    var contentType = headers.getContentType() || '';
    var hasJSONContentType = contentType.indexOf('application/json') > -1;
    var isObjectPayload = utils.isObject(data);
    if (isObjectPayload && utils.isHTMLForm(data)) {
      data = new FormData(data);
    }
    var isFormData = utils.isFormData(data);
    if (isFormData) {
      if (!hasJSONContentType) {
        return data;
      }
      return hasJSONContentType ? JSON.stringify(formDataToJSON(data)) : data;
    }
    if (utils.isArrayBuffer(data) || utils.isBuffer(data) || utils.isStream(data) || utils.isFile(data) || utils.isBlob(data)) {
      return data;
    }
    if (utils.isArrayBufferView(data)) {
      return data.buffer;
    }
    if (utils.isURLSearchParams(data)) {
      headers.setContentType('application/x-www-form-urlencoded;charset=utf-8', false);
      return data.toString();
    }
    var isFileList;
    if (isObjectPayload) {
      if (contentType.indexOf('application/x-www-form-urlencoded') > -1) {
        return toURLEncodedForm(data, this.formSerializer).toString();
      }
      if ((isFileList = utils.isFileList(data)) || contentType.indexOf('multipart/form-data') > -1) {
        var _FormData = this.env && this.env.FormData;
        return toFormData(isFileList ? {
          'files[]': data
        } : data, _FormData && new _FormData(), this.formSerializer);
      }
    }
    if (isObjectPayload || hasJSONContentType) {
      headers.setContentType('application/json', false);
      return stringifySafely(data);
    }
    return data;
  }],
  transformResponse: [function transformResponse(data) {
    var transitional = this.transitional || defaults.transitional;
    var forcedJSONParsing = transitional && transitional.forcedJSONParsing;
    var JSONRequested = this.responseType === 'json';
    if (data && utils.isString(data) && (forcedJSONParsing && !this.responseType || JSONRequested)) {
      var silentJSONParsing = transitional && transitional.silentJSONParsing;
      var strictJSONParsing = !silentJSONParsing && JSONRequested;
      try {
        return JSON.parse(data);
      } catch (e) {
        if (strictJSONParsing) {
          if (e.name === 'SyntaxError') {
            throw AxiosError.from(e, AxiosError.ERR_BAD_RESPONSE, this, null, this.response);
          }
          throw e;
        }
      }
    }
    return data;
  }],
  timeout: 0,
  xsrfCookieName: 'XSRF-TOKEN',
  xsrfHeaderName: 'X-XSRF-TOKEN',
  maxContentLength: -1,
  maxBodyLength: -1,
  env: {
    FormData: platform.classes.FormData,
    Blob: platform.classes.Blob
  },
  validateStatus: function validateStatus(status) {
    return status >= 200 && status < 300;
  },
  headers: {
    common: {
      'Accept': 'application/json, text/plain, */*'
    }
  }
};
utils.forEach(['delete', 'get', 'head'], function forEachMethodNoData(method) {
  defaults.headers[method] = {};
});
utils.forEach(['post', 'put', 'patch'], function forEachMethodWithData(method) {
  defaults.headers[method] = utils.merge(DEFAULT_CONTENT_TYPE);
});

var ignoreDuplicateOf = utils.toObjectSet(['age', 'authorization', 'content-length', 'content-type', 'etag', 'expires', 'from', 'host', 'if-modified-since', 'if-unmodified-since', 'last-modified', 'location', 'max-forwards', 'proxy-authorization', 'referer', 'retry-after', 'user-agent']);
var parseHeaders = (function (rawHeaders) {
  var parsed = {};
  var key;
  var val;
  var i;
  rawHeaders && rawHeaders.split('\n').forEach(function parser(line) {
    i = line.indexOf(':');
    key = line.substring(0, i).trim().toLowerCase();
    val = line.substring(i + 1).trim();
    if (!key || parsed[key] && ignoreDuplicateOf[key]) {
      return;
    }
    if (key === 'set-cookie') {
      if (parsed[key]) {
        parsed[key].push(val);
      } else {
        parsed[key] = [val];
      }
    } else {
      parsed[key] = parsed[key] ? parsed[key] + ', ' + val : val;
    }
  });
  return parsed;
});

var $internals = Symbol('internals');
function normalizeHeader(header) {
  return header && String(header).trim().toLowerCase();
}
function normalizeValue(value) {
  if (value === false || value == null) {
    return value;
  }
  return utils.isArray(value) ? value.map(normalizeValue) : String(value);
}
function parseTokens(str) {
  var tokens = Object.create(null);
  var tokensRE = /([^\s,;=]+)\s*(?:=\s*([^,;]+))?/g;
  var match;
  while (match = tokensRE.exec(str)) {
    tokens[match[1]] = match[2];
  }
  return tokens;
}
var isValidHeaderName = function isValidHeaderName(str) {
  return /^[-_a-zA-Z0-9^`|~,!#$%&'*+.]+$/.test(str.trim());
};
function matchHeaderValue(context, value, header, filter, isHeaderNameFilter) {
  if (utils.isFunction(filter)) {
    return filter.call(this, value, header);
  }
  if (isHeaderNameFilter) {
    value = header;
  }
  if (!utils.isString(value)) return;
  if (utils.isString(filter)) {
    return value.indexOf(filter) !== -1;
  }
  if (utils.isRegExp(filter)) {
    return filter.test(value);
  }
}
function formatHeader(header) {
  return header.trim().toLowerCase().replace(/([a-z\d])(\w*)/g, function (w, _char, str) {
    return _char.toUpperCase() + str;
  });
}
function buildAccessors(obj, header) {
  var accessorName = utils.toCamelCase(' ' + header);
  ['get', 'set', 'has'].forEach(function (methodName) {
    Object.defineProperty(obj, methodName + accessorName, {
      value: function value(arg1, arg2, arg3) {
        return this[methodName].call(this, header, arg1, arg2, arg3);
      },
      configurable: true
    });
  });
}
var AxiosHeaders = /*#__PURE__*/function (_Symbol$iterator, _Symbol$toStringTag) {
  function AxiosHeaders(headers) {
    headers && this.set(headers);
  }
  var _proto = AxiosHeaders.prototype;
  _proto.set = function set(header, valueOrRewrite, rewrite) {
    var self = this;
    function setHeader(_value, _header, _rewrite) {
      var lHeader = normalizeHeader(_header);
      if (!lHeader) {
        throw new Error('header name must be a non-empty string');
      }
      var key = utils.findKey(self, lHeader);
      if (!key || self[key] === undefined || _rewrite === true || _rewrite === undefined && self[key] !== false) {
        self[key || _header] = normalizeValue(_value);
      }
    }
    var setHeaders = function setHeaders(headers, _rewrite) {
      return utils.forEach(headers, function (_value, _header) {
        return setHeader(_value, _header, _rewrite);
      });
    };
    if (utils.isPlainObject(header) || header instanceof this.constructor) {
      setHeaders(header, valueOrRewrite);
    } else if (utils.isString(header) && (header = header.trim()) && !isValidHeaderName(header)) {
      setHeaders(parseHeaders(header), valueOrRewrite);
    } else {
      header != null && setHeader(valueOrRewrite, header, rewrite);
    }
    return this;
  };
  _proto.get = function get(header, parser) {
    header = normalizeHeader(header);
    if (header) {
      var key = utils.findKey(this, header);
      if (key) {
        var value = this[key];
        if (!parser) {
          return value;
        }
        if (parser === true) {
          return parseTokens(value);
        }
        if (utils.isFunction(parser)) {
          return parser.call(this, value, key);
        }
        if (utils.isRegExp(parser)) {
          return parser.exec(value);
        }
        throw new TypeError('parser must be boolean|regexp|function');
      }
    }
  };
  _proto.has = function has(header, matcher) {
    header = normalizeHeader(header);
    if (header) {
      var key = utils.findKey(this, header);
      return !!(key && this[key] !== undefined && (!matcher || matchHeaderValue(this, this[key], key, matcher)));
    }
    return false;
  };
  _proto["delete"] = function _delete(header, matcher) {
    var self = this;
    var deleted = false;
    function deleteHeader(_header) {
      _header = normalizeHeader(_header);
      if (_header) {
        var key = utils.findKey(self, _header);
        if (key && (!matcher || matchHeaderValue(self, self[key], key, matcher))) {
          delete self[key];
          deleted = true;
        }
      }
    }
    if (utils.isArray(header)) {
      header.forEach(deleteHeader);
    } else {
      deleteHeader(header);
    }
    return deleted;
  };
  _proto.clear = function clear(matcher) {
    var keys = Object.keys(this);
    var i = keys.length;
    var deleted = false;
    while (i--) {
      var key = keys[i];
      if (!matcher || matchHeaderValue(this, this[key], key, matcher, true)) {
        delete this[key];
        deleted = true;
      }
    }
    return deleted;
  };
  _proto.normalize = function normalize(format) {
    var self = this;
    var headers = {};
    utils.forEach(this, function (value, header) {
      var key = utils.findKey(headers, header);
      if (key) {
        self[key] = normalizeValue(value);
        delete self[header];
        return;
      }
      var normalized = format ? formatHeader(header) : String(header).trim();
      if (normalized !== header) {
        delete self[header];
      }
      self[normalized] = normalizeValue(value);
      headers[normalized] = true;
    });
    return this;
  };
  _proto.concat = function concat() {
    var _this$constructor;
    for (var _len = arguments.length, targets = new Array(_len), _key = 0; _key < _len; _key++) {
      targets[_key] = arguments[_key];
    }
    return (_this$constructor = this.constructor).concat.apply(_this$constructor, [this].concat(targets));
  };
  _proto.toJSON = function toJSON(asStrings) {
    var obj = Object.create(null);
    utils.forEach(this, function (value, header) {
      value != null && value !== false && (obj[header] = asStrings && utils.isArray(value) ? value.join(', ') : value);
    });
    return obj;
  };
  _proto[_Symbol$iterator] = function () {
    return Object.entries(this.toJSON())[Symbol.iterator]();
  };
  _proto.toString = function toString() {
    return Object.entries(this.toJSON()).map(function (_ref) {
      var header = _ref[0],
        value = _ref[1];
      return header + ': ' + value;
    }).join('\n');
  };
  AxiosHeaders.from = function from(thing) {
    return thing instanceof this ? thing : new this(thing);
  };
  AxiosHeaders.concat = function concat(first) {
    var computed = new this(first);
    for (var _len2 = arguments.length, targets = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
      targets[_key2 - 1] = arguments[_key2];
    }
    targets.forEach(function (target) {
      return computed.set(target);
    });
    return computed;
  };
  AxiosHeaders.accessor = function accessor(header) {
    var internals = this[$internals] = this[$internals] = {
      accessors: {}
    };
    var accessors = internals.accessors;
    var prototype = this.prototype;
    function defineAccessor(_header) {
      var lHeader = normalizeHeader(_header);
      if (!accessors[lHeader]) {
        buildAccessors(prototype, _header);
        accessors[lHeader] = true;
      }
    }
    utils.isArray(header) ? header.forEach(defineAccessor) : defineAccessor(header);
    return this;
  };
  _createClass(AxiosHeaders, [{
    key: _Symbol$toStringTag,
    get: function get() {
      return 'AxiosHeaders';
    }
  }]);
  return AxiosHeaders;
}(Symbol.iterator, Symbol.toStringTag);
AxiosHeaders.accessor(['Content-Type', 'Content-Length', 'Accept', 'Accept-Encoding', 'User-Agent', 'Authorization']);
utils.freezeMethods(AxiosHeaders.prototype);
utils.freezeMethods(AxiosHeaders);

function transformData(fns, response) {
  var config = this || defaults;
  var context = response || config;
  var headers = AxiosHeaders.from(context.headers);
  var data = context.data;
  utils.forEach(fns, function transform(fn) {
    data = fn.call(config, data, headers.normalize(), response ? response.status : undefined);
  });
  headers.normalize();
  return data;
}

function isCancel(value) {
  return !!(value && value.__CANCEL__);
}

function CanceledError(message, config, request) {
  AxiosError.call(this, message == null ? 'canceled' : message, AxiosError.ERR_CANCELED, config, request);
  this.name = 'CanceledError';
}
utils.inherits(CanceledError, AxiosError, {
  __CANCEL__: true
});

function settle(resolve, reject, response) {
  var validateStatus = response.config.validateStatus;
  if (!response.status || !validateStatus || validateStatus(response.status)) {
    resolve(response);
  } else {
    reject(new AxiosError('Request failed with status code ' + response.status, [AxiosError.ERR_BAD_REQUEST, AxiosError.ERR_BAD_RESPONSE][Math.floor(response.status / 100) - 4], response.config, response.request, response));
  }
}

var cookies = platform.isStandardBrowserEnv ? function standardBrowserEnv() {
  return {
    write: function write(name, value, expires, path, domain, secure) {
      var cookie = [];
      cookie.push(name + '=' + encodeURIComponent(value));
      if (utils.isNumber(expires)) {
        cookie.push('expires=' + new Date(expires).toGMTString());
      }
      if (utils.isString(path)) {
        cookie.push('path=' + path);
      }
      if (utils.isString(domain)) {
        cookie.push('domain=' + domain);
      }
      if (secure === true) {
        cookie.push('secure');
      }
      document.cookie = cookie.join('; ');
    },
    read: function read(name) {
      var match = document.cookie.match(new RegExp('(^|;\\s*)(' + name + ')=([^;]*)'));
      return match ? decodeURIComponent(match[3]) : null;
    },
    remove: function remove(name) {
      this.write(name, '', Date.now() - 86400000);
    }
  };
}() : function nonStandardBrowserEnv() {
  return {
    write: function write() {},
    read: function read() {
      return null;
    },
    remove: function remove() {}
  };
}();

function isAbsoluteURL(url) {
  return /^([a-z][a-z\d+\-.]*:)?\/\//i.test(url);
}

function combineURLs(baseURL, relativeURL) {
  return relativeURL ? baseURL.replace(/\/+$/, '') + '/' + relativeURL.replace(/^\/+/, '') : baseURL;
}

function buildFullPath(baseURL, requestedURL) {
  if (baseURL && !isAbsoluteURL(requestedURL)) {
    return combineURLs(baseURL, requestedURL);
  }
  return requestedURL;
}

var isURLSameOrigin = platform.isStandardBrowserEnv ? function standardBrowserEnv() {
  var msie = /(msie|trident)/i.test(navigator.userAgent);
  var urlParsingNode = document.createElement('a');
  var originURL;
  function resolveURL(url) {
    var href = url;
    if (msie) {
      urlParsingNode.setAttribute('href', href);
      href = urlParsingNode.href;
    }
    urlParsingNode.setAttribute('href', href);
    return {
      href: urlParsingNode.href,
      protocol: urlParsingNode.protocol ? urlParsingNode.protocol.replace(/:$/, '') : '',
      host: urlParsingNode.host,
      search: urlParsingNode.search ? urlParsingNode.search.replace(/^\?/, '') : '',
      hash: urlParsingNode.hash ? urlParsingNode.hash.replace(/^#/, '') : '',
      hostname: urlParsingNode.hostname,
      port: urlParsingNode.port,
      pathname: urlParsingNode.pathname.charAt(0) === '/' ? urlParsingNode.pathname : '/' + urlParsingNode.pathname
    };
  }
  originURL = resolveURL(window.location.href);
  return function isURLSameOrigin(requestURL) {
    var parsed = utils.isString(requestURL) ? resolveURL(requestURL) : requestURL;
    return parsed.protocol === originURL.protocol && parsed.host === originURL.host;
  };
}() : function nonStandardBrowserEnv() {
  return function isURLSameOrigin() {
    return true;
  };
}();

function parseProtocol(url) {
  var match = /^([-+\w]{1,25})(:?\/\/|:)/.exec(url);
  return match && match[1] || '';
}

function speedometer(samplesCount, min) {
  samplesCount = samplesCount || 10;
  var bytes = new Array(samplesCount);
  var timestamps = new Array(samplesCount);
  var head = 0;
  var tail = 0;
  var firstSampleTS;
  min = min !== undefined ? min : 1000;
  return function push(chunkLength) {
    var now = Date.now();
    var startedAt = timestamps[tail];
    if (!firstSampleTS) {
      firstSampleTS = now;
    }
    bytes[head] = chunkLength;
    timestamps[head] = now;
    var i = tail;
    var bytesCount = 0;
    while (i !== head) {
      bytesCount += bytes[i++];
      i = i % samplesCount;
    }
    head = (head + 1) % samplesCount;
    if (head === tail) {
      tail = (tail + 1) % samplesCount;
    }
    if (now - firstSampleTS < min) {
      return;
    }
    var passed = startedAt && now - startedAt;
    return passed ? Math.round(bytesCount * 1000 / passed) : undefined;
  };
}

function progressEventReducer(listener, isDownloadStream) {
  var bytesNotified = 0;
  var _speedometer = speedometer(50, 250);
  return function (e) {
    var loaded = e.loaded;
    var total = e.lengthComputable ? e.total : undefined;
    var progressBytes = loaded - bytesNotified;
    var rate = _speedometer(progressBytes);
    var inRange = loaded <= total;
    bytesNotified = loaded;
    var data = {
      loaded: loaded,
      total: total,
      progress: total ? loaded / total : undefined,
      bytes: progressBytes,
      rate: rate ? rate : undefined,
      estimated: rate && total && inRange ? (total - loaded) / rate : undefined,
      event: e
    };
    data[isDownloadStream ? 'download' : 'upload'] = true;
    listener(data);
  };
}
var isXHRAdapterSupported = typeof XMLHttpRequest !== 'undefined';
var xhrAdapter = isXHRAdapterSupported && function (config) {
  return new Promise(function dispatchXhrRequest(resolve, reject) {
    var requestData = config.data;
    var requestHeaders = AxiosHeaders.from(config.headers).normalize();
    var responseType = config.responseType;
    var onCanceled;
    function done() {
      if (config.cancelToken) {
        config.cancelToken.unsubscribe(onCanceled);
      }
      if (config.signal) {
        config.signal.removeEventListener('abort', onCanceled);
      }
    }
    if (utils.isFormData(requestData)) {
      if (platform.isStandardBrowserEnv || platform.isStandardBrowserWebWorkerEnv) {
        requestHeaders.setContentType(false);
      } else {
        requestHeaders.setContentType('multipart/form-data;', false);
      }
    }
    var request = new XMLHttpRequest();
    if (config.auth) {
      var username = config.auth.username || '';
      var password = config.auth.password ? unescape(encodeURIComponent(config.auth.password)) : '';
      requestHeaders.set('Authorization', 'Basic ' + btoa(username + ':' + password));
    }
    var fullPath = buildFullPath(config.baseURL, config.url);
    request.open(config.method.toUpperCase(), buildURL(fullPath, config.params, config.paramsSerializer), true);
    request.timeout = config.timeout;
    function onloadend() {
      if (!request) {
        return;
      }
      var responseHeaders = AxiosHeaders.from('getAllResponseHeaders' in request && request.getAllResponseHeaders());
      var responseData = !responseType || responseType === 'text' || responseType === 'json' ? request.responseText : request.response;
      var response = {
        data: responseData,
        status: request.status,
        statusText: request.statusText,
        headers: responseHeaders,
        config: config,
        request: request
      };
      settle(function _resolve(value) {
        resolve(value);
        done();
      }, function _reject(err) {
        reject(err);
        done();
      }, response);
      request = null;
    }
    if ('onloadend' in request) {
      request.onloadend = onloadend;
    } else {
      request.onreadystatechange = function handleLoad() {
        if (!request || request.readyState !== 4) {
          return;
        }
        if (request.status === 0 && !(request.responseURL && request.responseURL.indexOf('file:') === 0)) {
          return;
        }
        setTimeout(onloadend);
      };
    }
    request.onabort = function handleAbort() {
      if (!request) {
        return;
      }
      reject(new AxiosError('Request aborted', AxiosError.ECONNABORTED, config, request));
      request = null;
    };
    request.onerror = function handleError() {
      reject(new AxiosError('Network Error', AxiosError.ERR_NETWORK, config, request));
      request = null;
    };
    request.ontimeout = function handleTimeout() {
      var timeoutErrorMessage = config.timeout ? 'timeout of ' + config.timeout + 'ms exceeded' : 'timeout exceeded';
      var transitional = config.transitional || transitionalDefaults;
      if (config.timeoutErrorMessage) {
        timeoutErrorMessage = config.timeoutErrorMessage;
      }
      reject(new AxiosError(timeoutErrorMessage, transitional.clarifyTimeoutError ? AxiosError.ETIMEDOUT : AxiosError.ECONNABORTED, config, request));
      request = null;
    };
    if (platform.isStandardBrowserEnv) {
      var xsrfValue = (config.withCredentials || isURLSameOrigin(fullPath)) && config.xsrfCookieName && cookies.read(config.xsrfCookieName);
      if (xsrfValue) {
        requestHeaders.set(config.xsrfHeaderName, xsrfValue);
      }
    }
    requestData === undefined && requestHeaders.setContentType(null);
    if ('setRequestHeader' in request) {
      utils.forEach(requestHeaders.toJSON(), function setRequestHeader(val, key) {
        request.setRequestHeader(key, val);
      });
    }
    if (!utils.isUndefined(config.withCredentials)) {
      request.withCredentials = !!config.withCredentials;
    }
    if (responseType && responseType !== 'json') {
      request.responseType = config.responseType;
    }
    if (typeof config.onDownloadProgress === 'function') {
      request.addEventListener('progress', progressEventReducer(config.onDownloadProgress, true));
    }
    if (typeof config.onUploadProgress === 'function' && request.upload) {
      request.upload.addEventListener('progress', progressEventReducer(config.onUploadProgress));
    }
    if (config.cancelToken || config.signal) {
      onCanceled = function onCanceled(cancel) {
        if (!request) {
          return;
        }
        reject(!cancel || cancel.type ? new CanceledError(null, config, request) : cancel);
        request.abort();
        request = null;
      };
      config.cancelToken && config.cancelToken.subscribe(onCanceled);
      if (config.signal) {
        config.signal.aborted ? onCanceled() : config.signal.addEventListener('abort', onCanceled);
      }
    }
    var protocol = parseProtocol(fullPath);
    if (protocol && platform.protocols.indexOf(protocol) === -1) {
      reject(new AxiosError('Unsupported protocol ' + protocol + ':', AxiosError.ERR_BAD_REQUEST, config));
      return;
    }
    request.send(requestData || null);
  });
};

var knownAdapters = {
  http: httpAdapter,
  xhr: xhrAdapter
};
utils.forEach(knownAdapters, function (fn, value) {
  if (fn) {
    try {
      Object.defineProperty(fn, 'name', {
        value: value
      });
    } catch (e) {}
    Object.defineProperty(fn, 'adapterName', {
      value: value
    });
  }
});
var adapters = {
  getAdapter: function getAdapter(adapters) {
    adapters = utils.isArray(adapters) ? adapters : [adapters];
    var _adapters = adapters,
      length = _adapters.length;
    var nameOrAdapter;
    var adapter;
    for (var i = 0; i < length; i++) {
      nameOrAdapter = adapters[i];
      if (adapter = utils.isString(nameOrAdapter) ? knownAdapters[nameOrAdapter.toLowerCase()] : nameOrAdapter) {
        break;
      }
    }
    if (!adapter) {
      if (adapter === false) {
        throw new AxiosError("Adapter " + nameOrAdapter + " is not supported by the environment", 'ERR_NOT_SUPPORT');
      }
      throw new Error(utils.hasOwnProp(knownAdapters, nameOrAdapter) ? "Adapter '" + nameOrAdapter + "' is not available in the build" : "Unknown adapter '" + nameOrAdapter + "'");
    }
    if (!utils.isFunction(adapter)) {
      throw new TypeError('adapter is not a function');
    }
    return adapter;
  },
  adapters: knownAdapters
};

function throwIfCancellationRequested(config) {
  if (config.cancelToken) {
    config.cancelToken.throwIfRequested();
  }
  if (config.signal && config.signal.aborted) {
    throw new CanceledError(null, config);
  }
}
function dispatchRequest(config) {
  throwIfCancellationRequested(config);
  config.headers = AxiosHeaders.from(config.headers);
  config.data = transformData.call(config, config.transformRequest);
  if (['post', 'put', 'patch'].indexOf(config.method) !== -1) {
    config.headers.setContentType('application/x-www-form-urlencoded', false);
  }
  var adapter = adapters.getAdapter(config.adapter || defaults.adapter);
  return adapter(config).then(function onAdapterResolution(response) {
    throwIfCancellationRequested(config);
    response.data = transformData.call(config, config.transformResponse, response);
    response.headers = AxiosHeaders.from(response.headers);
    return response;
  }, function onAdapterRejection(reason) {
    if (!isCancel(reason)) {
      throwIfCancellationRequested(config);
      if (reason && reason.response) {
        reason.response.data = transformData.call(config, config.transformResponse, reason.response);
        reason.response.headers = AxiosHeaders.from(reason.response.headers);
      }
    }
    return Promise.reject(reason);
  });
}

var headersToObject = function headersToObject(thing) {
  return thing instanceof AxiosHeaders ? thing.toJSON() : thing;
};
function mergeConfig(config1, config2) {
  config2 = config2 || {};
  var config = {};
  function getMergedValue(target, source, caseless) {
    if (utils.isPlainObject(target) && utils.isPlainObject(source)) {
      return utils.merge.call({
        caseless: caseless
      }, target, source);
    } else if (utils.isPlainObject(source)) {
      return utils.merge({}, source);
    } else if (utils.isArray(source)) {
      return source.slice();
    }
    return source;
  }
  function mergeDeepProperties(a, b, caseless) {
    if (!utils.isUndefined(b)) {
      return getMergedValue(a, b, caseless);
    } else if (!utils.isUndefined(a)) {
      return getMergedValue(undefined, a, caseless);
    }
  }
  function valueFromConfig2(a, b) {
    if (!utils.isUndefined(b)) {
      return getMergedValue(undefined, b);
    }
  }
  function defaultToConfig2(a, b) {
    if (!utils.isUndefined(b)) {
      return getMergedValue(undefined, b);
    } else if (!utils.isUndefined(a)) {
      return getMergedValue(undefined, a);
    }
  }
  function mergeDirectKeys(a, b, prop) {
    if (prop in config2) {
      return getMergedValue(a, b);
    } else if (prop in config1) {
      return getMergedValue(undefined, a);
    }
  }
  var mergeMap = {
    url: valueFromConfig2,
    method: valueFromConfig2,
    data: valueFromConfig2,
    baseURL: defaultToConfig2,
    transformRequest: defaultToConfig2,
    transformResponse: defaultToConfig2,
    paramsSerializer: defaultToConfig2,
    timeout: defaultToConfig2,
    timeoutMessage: defaultToConfig2,
    withCredentials: defaultToConfig2,
    adapter: defaultToConfig2,
    responseType: defaultToConfig2,
    xsrfCookieName: defaultToConfig2,
    xsrfHeaderName: defaultToConfig2,
    onUploadProgress: defaultToConfig2,
    onDownloadProgress: defaultToConfig2,
    decompress: defaultToConfig2,
    maxContentLength: defaultToConfig2,
    maxBodyLength: defaultToConfig2,
    beforeRedirect: defaultToConfig2,
    transport: defaultToConfig2,
    httpAgent: defaultToConfig2,
    httpsAgent: defaultToConfig2,
    cancelToken: defaultToConfig2,
    socketPath: defaultToConfig2,
    responseEncoding: defaultToConfig2,
    validateStatus: mergeDirectKeys,
    headers: function headers(a, b) {
      return mergeDeepProperties(headersToObject(a), headersToObject(b), true);
    }
  };
  utils.forEach(Object.keys(Object.assign({}, config1, config2)), function computeConfigValue(prop) {
    var merge = mergeMap[prop] || mergeDeepProperties;
    var configValue = merge(config1[prop], config2[prop], prop);
    utils.isUndefined(configValue) && merge !== mergeDirectKeys || (config[prop] = configValue);
  });
  return config;
}

var VERSION = "1.4.0";

var validators = {};
['object', 'boolean', 'number', 'function', 'string', 'symbol'].forEach(function (type, i) {
  validators[type] = function validator(thing) {
    return typeof thing === type || 'a' + (i < 1 ? 'n ' : ' ') + type;
  };
});
var deprecatedWarnings = {};
validators.transitional = function transitional(validator, version, message) {
  function formatMessage(opt, desc) {
    return '[Axios v' + VERSION + '] Transitional option \'' + opt + '\'' + desc + (message ? '. ' + message : '');
  }
  return function (value, opt, opts) {
    if (validator === false) {
      throw new AxiosError(formatMessage(opt, ' has been removed' + (version ? ' in ' + version : '')), AxiosError.ERR_DEPRECATED);
    }
    if (version && !deprecatedWarnings[opt]) {
      deprecatedWarnings[opt] = true;
      console.warn(formatMessage(opt, ' has been deprecated since v' + version + ' and will be removed in the near future'));
    }
    return validator ? validator(value, opt, opts) : true;
  };
};
function assertOptions(options, schema, allowUnknown) {
  if (typeof options !== 'object') {
    throw new AxiosError('options must be an object', AxiosError.ERR_BAD_OPTION_VALUE);
  }
  var keys = Object.keys(options);
  var i = keys.length;
  while (i-- > 0) {
    var opt = keys[i];
    var validator = schema[opt];
    if (validator) {
      var value = options[opt];
      var result = value === undefined || validator(value, opt, options);
      if (result !== true) {
        throw new AxiosError('option ' + opt + ' must be ' + result, AxiosError.ERR_BAD_OPTION_VALUE);
      }
      continue;
    }
    if (allowUnknown !== true) {
      throw new AxiosError('Unknown option ' + opt, AxiosError.ERR_BAD_OPTION);
    }
  }
}
var validator = {
  assertOptions: assertOptions,
  validators: validators
};

var validators$1 = validator.validators;
var Axios = /*#__PURE__*/function () {
  function Axios(instanceConfig) {
    this.defaults = instanceConfig;
    this.interceptors = {
      request: new InterceptorManager(),
      response: new InterceptorManager()
    };
  }
  var _proto = Axios.prototype;
  _proto.request = function request(configOrUrl, config) {
    if (typeof configOrUrl === 'string') {
      config = config || {};
      config.url = configOrUrl;
    } else {
      config = configOrUrl || {};
    }
    config = mergeConfig(this.defaults, config);
    var _config = config,
      transitional = _config.transitional,
      paramsSerializer = _config.paramsSerializer,
      headers = _config.headers;
    if (transitional !== undefined) {
      validator.assertOptions(transitional, {
        silentJSONParsing: validators$1.transitional(validators$1["boolean"]),
        forcedJSONParsing: validators$1.transitional(validators$1["boolean"]),
        clarifyTimeoutError: validators$1.transitional(validators$1["boolean"])
      }, false);
    }
    if (paramsSerializer != null) {
      if (utils.isFunction(paramsSerializer)) {
        config.paramsSerializer = {
          serialize: paramsSerializer
        };
      } else {
        validator.assertOptions(paramsSerializer, {
          encode: validators$1["function"],
          serialize: validators$1["function"]
        }, true);
      }
    }
    config.method = (config.method || this.defaults.method || 'get').toLowerCase();
    var contextHeaders;
    contextHeaders = headers && utils.merge(headers.common, headers[config.method]);
    contextHeaders && utils.forEach(['delete', 'get', 'head', 'post', 'put', 'patch', 'common'], function (method) {
      delete headers[method];
    });
    config.headers = AxiosHeaders.concat(contextHeaders, headers);
    var requestInterceptorChain = [];
    var synchronousRequestInterceptors = true;
    this.interceptors.request.forEach(function unshiftRequestInterceptors(interceptor) {
      if (typeof interceptor.runWhen === 'function' && interceptor.runWhen(config) === false) {
        return;
      }
      synchronousRequestInterceptors = synchronousRequestInterceptors && interceptor.synchronous;
      requestInterceptorChain.unshift(interceptor.fulfilled, interceptor.rejected);
    });
    var responseInterceptorChain = [];
    this.interceptors.response.forEach(function pushResponseInterceptors(interceptor) {
      responseInterceptorChain.push(interceptor.fulfilled, interceptor.rejected);
    });
    var promise;
    var i = 0;
    var len;
    if (!synchronousRequestInterceptors) {
      var chain = [dispatchRequest.bind(this), undefined];
      chain.unshift.apply(chain, requestInterceptorChain);
      chain.push.apply(chain, responseInterceptorChain);
      len = chain.length;
      promise = Promise.resolve(config);
      while (i < len) {
        promise = promise.then(chain[i++], chain[i++]);
      }
      return promise;
    }
    len = requestInterceptorChain.length;
    var newConfig = config;
    i = 0;
    while (i < len) {
      var onFulfilled = requestInterceptorChain[i++];
      var onRejected = requestInterceptorChain[i++];
      try {
        newConfig = onFulfilled(newConfig);
      } catch (error) {
        onRejected.call(this, error);
        break;
      }
    }
    try {
      promise = dispatchRequest.call(this, newConfig);
    } catch (error) {
      return Promise.reject(error);
    }
    i = 0;
    len = responseInterceptorChain.length;
    while (i < len) {
      promise = promise.then(responseInterceptorChain[i++], responseInterceptorChain[i++]);
    }
    return promise;
  };
  _proto.getUri = function getUri(config) {
    config = mergeConfig(this.defaults, config);
    var fullPath = buildFullPath(config.baseURL, config.url);
    return buildURL(fullPath, config.params, config.paramsSerializer);
  };
  return Axios;
}();
utils.forEach(['delete', 'get', 'head', 'options'], function forEachMethodNoData(method) {
  Axios.prototype[method] = function (url, config) {
    return this.request(mergeConfig(config || {}, {
      method: method,
      url: url,
      data: (config || {}).data
    }));
  };
});
utils.forEach(['post', 'put', 'patch'], function forEachMethodWithData(method) {
  function generateHTTPMethod(isForm) {
    return function httpMethod(url, data, config) {
      return this.request(mergeConfig(config || {}, {
        method: method,
        headers: isForm ? {
          'Content-Type': 'multipart/form-data'
        } : {},
        url: url,
        data: data
      }));
    };
  }
  Axios.prototype[method] = generateHTTPMethod();
  Axios.prototype[method + 'Form'] = generateHTTPMethod(true);
});

var CancelToken = /*#__PURE__*/function () {
  function CancelToken(executor) {
    if (typeof executor !== 'function') {
      throw new TypeError('executor must be a function.');
    }
    var resolvePromise;
    this.promise = new Promise(function promiseExecutor(resolve) {
      resolvePromise = resolve;
    });
    var token = this;
    this.promise.then(function (cancel) {
      if (!token._listeners) return;
      var i = token._listeners.length;
      while (i-- > 0) {
        token._listeners[i](cancel);
      }
      token._listeners = null;
    });
    this.promise.then = function (onfulfilled) {
      var _resolve;
      var promise = new Promise(function (resolve) {
        token.subscribe(resolve);
        _resolve = resolve;
      }).then(onfulfilled);
      promise.cancel = function reject() {
        token.unsubscribe(_resolve);
      };
      return promise;
    };
    executor(function cancel(message, config, request) {
      if (token.reason) {
        return;
      }
      token.reason = new CanceledError(message, config, request);
      resolvePromise(token.reason);
    });
  }
  var _proto = CancelToken.prototype;
  _proto.throwIfRequested = function throwIfRequested() {
    if (this.reason) {
      throw this.reason;
    }
  };
  _proto.subscribe = function subscribe(listener) {
    if (this.reason) {
      listener(this.reason);
      return;
    }
    if (this._listeners) {
      this._listeners.push(listener);
    } else {
      this._listeners = [listener];
    }
  };
  _proto.unsubscribe = function unsubscribe(listener) {
    if (!this._listeners) {
      return;
    }
    var index = this._listeners.indexOf(listener);
    if (index !== -1) {
      this._listeners.splice(index, 1);
    }
  };
  CancelToken.source = function source() {
    var cancel;
    var token = new CancelToken(function executor(c) {
      cancel = c;
    });
    return {
      token: token,
      cancel: cancel
    };
  };
  return CancelToken;
}();

function spread(callback) {
  return function wrap(arr) {
    return callback.apply(null, arr);
  };
}

function isAxiosError(payload) {
  return utils.isObject(payload) && payload.isAxiosError === true;
}

var HttpStatusCode = {
  Continue: 100,
  SwitchingProtocols: 101,
  Processing: 102,
  EarlyHints: 103,
  Ok: 200,
  Created: 201,
  Accepted: 202,
  NonAuthoritativeInformation: 203,
  NoContent: 204,
  ResetContent: 205,
  PartialContent: 206,
  MultiStatus: 207,
  AlreadyReported: 208,
  ImUsed: 226,
  MultipleChoices: 300,
  MovedPermanently: 301,
  Found: 302,
  SeeOther: 303,
  NotModified: 304,
  UseProxy: 305,
  Unused: 306,
  TemporaryRedirect: 307,
  PermanentRedirect: 308,
  BadRequest: 400,
  Unauthorized: 401,
  PaymentRequired: 402,
  Forbidden: 403,
  NotFound: 404,
  MethodNotAllowed: 405,
  NotAcceptable: 406,
  ProxyAuthenticationRequired: 407,
  RequestTimeout: 408,
  Conflict: 409,
  Gone: 410,
  LengthRequired: 411,
  PreconditionFailed: 412,
  PayloadTooLarge: 413,
  UriTooLong: 414,
  UnsupportedMediaType: 415,
  RangeNotSatisfiable: 416,
  ExpectationFailed: 417,
  ImATeapot: 418,
  MisdirectedRequest: 421,
  UnprocessableEntity: 422,
  Locked: 423,
  FailedDependency: 424,
  TooEarly: 425,
  UpgradeRequired: 426,
  PreconditionRequired: 428,
  TooManyRequests: 429,
  RequestHeaderFieldsTooLarge: 431,
  UnavailableForLegalReasons: 451,
  InternalServerError: 500,
  NotImplemented: 501,
  BadGateway: 502,
  ServiceUnavailable: 503,
  GatewayTimeout: 504,
  HttpVersionNotSupported: 505,
  VariantAlsoNegotiates: 506,
  InsufficientStorage: 507,
  LoopDetected: 508,
  NotExtended: 510,
  NetworkAuthenticationRequired: 511
};
Object.entries(HttpStatusCode).forEach(function (_ref) {
  var key = _ref[0],
    value = _ref[1];
  HttpStatusCode[value] = key;
});

function createInstance(defaultConfig) {
  var context = new Axios(defaultConfig);
  var instance = bind(Axios.prototype.request, context);
  utils.extend(instance, Axios.prototype, context, {
    allOwnKeys: true
  });
  utils.extend(instance, context, null, {
    allOwnKeys: true
  });
  instance.create = function create(instanceConfig) {
    return createInstance(mergeConfig(defaultConfig, instanceConfig));
  };
  return instance;
}
var axios = createInstance(defaults);
axios.Axios = Axios;
axios.CanceledError = CanceledError;
axios.CancelToken = CancelToken;
axios.isCancel = isCancel;
axios.VERSION = VERSION;
axios.toFormData = toFormData;
axios.AxiosError = AxiosError;
axios.Cancel = axios.CanceledError;
axios.all = function all(promises) {
  return Promise.all(promises);
};
axios.spread = spread;
axios.isAxiosError = isAxiosError;
axios.mergeConfig = mergeConfig;
axios.AxiosHeaders = AxiosHeaders;
axios.formToJSON = function (thing) {
  return formDataToJSON(utils.isHTMLForm(thing) ? new FormData(thing) : thing);
};
axios.HttpStatusCode = HttpStatusCode;
axios["default"] = axios;

var shams = function hasSymbols() {
  if (typeof Symbol !== 'function' || typeof Object.getOwnPropertySymbols !== 'function') {
    return false;
  }
  if (typeof Symbol.iterator === 'symbol') {
    return true;
  }
  var obj = {};
  var sym = Symbol('test');
  var symObj = Object(sym);
  if (typeof sym === 'string') {
    return false;
  }
  if (Object.prototype.toString.call(sym) !== '[object Symbol]') {
    return false;
  }
  if (Object.prototype.toString.call(symObj) !== '[object Symbol]') {
    return false;
  }
  var symVal = 42;
  obj[sym] = symVal;
  for (sym in obj) {
    return false;
  }
  if (typeof Object.keys === 'function' && Object.keys(obj).length !== 0) {
    return false;
  }
  if (typeof Object.getOwnPropertyNames === 'function' && Object.getOwnPropertyNames(obj).length !== 0) {
    return false;
  }
  var syms = Object.getOwnPropertySymbols(obj);
  if (syms.length !== 1 || syms[0] !== sym) {
    return false;
  }
  if (!Object.prototype.propertyIsEnumerable.call(obj, sym)) {
    return false;
  }
  if (typeof Object.getOwnPropertyDescriptor === 'function') {
    var descriptor = Object.getOwnPropertyDescriptor(obj, sym);
    if (descriptor.value !== symVal || descriptor.enumerable !== true) {
      return false;
    }
  }
  return true;
};

var origSymbol = typeof Symbol !== 'undefined' && Symbol;
var hasSymbols = function hasNativeSymbols() {
  if (typeof origSymbol !== 'function') {
    return false;
  }
  if (typeof Symbol !== 'function') {
    return false;
  }
  if (typeof origSymbol('foo') !== 'symbol') {
    return false;
  }
  if (typeof Symbol('bar') !== 'symbol') {
    return false;
  }
  return shams();
};

var test = {
  foo: {}
};
var $Object = Object;
var hasProto = function hasProto() {
  return {
    __proto__: test
  }.foo === test.foo && !({
    __proto__: null
  } instanceof $Object);
};

var ERROR_MESSAGE = 'Function.prototype.bind called on incompatible ';
var slice = Array.prototype.slice;
var toStr = Object.prototype.toString;
var funcType = '[object Function]';
var implementation = function bind(that) {
  var target = this;
  if (typeof target !== 'function' || toStr.call(target) !== funcType) {
    throw new TypeError(ERROR_MESSAGE + target);
  }
  var args = slice.call(arguments, 1);
  var bound;
  var binder = function binder() {
    if (this instanceof bound) {
      var result = target.apply(this, args.concat(slice.call(arguments)));
      if (Object(result) === result) {
        return result;
      }
      return this;
    } else {
      return target.apply(that, args.concat(slice.call(arguments)));
    }
  };
  var boundLength = Math.max(0, target.length - args.length);
  var boundArgs = [];
  for (var i = 0; i < boundLength; i++) {
    boundArgs.push('$' + i);
  }
  bound = Function('binder', 'return function (' + boundArgs.join(',') + '){ return binder.apply(this,arguments); }')(binder);
  if (target.prototype) {
    var Empty = function Empty() {};
    Empty.prototype = target.prototype;
    bound.prototype = new Empty();
    Empty.prototype = null;
  }
  return bound;
};

var functionBind = Function.prototype.bind || implementation;

var src = functionBind.call(Function.call, Object.prototype.hasOwnProperty);

var undefined$1;
var $SyntaxError = SyntaxError;
var $Function = Function;
var $TypeError = TypeError;
var getEvalledConstructor = function getEvalledConstructor(expressionSyntax) {
  try {
    return $Function('"use strict"; return (' + expressionSyntax + ').constructor;')();
  } catch (e) {}
};
var $gOPD = Object.getOwnPropertyDescriptor;
if ($gOPD) {
  try {
    $gOPD({}, '');
  } catch (e) {
    $gOPD = null;
  }
}
var throwTypeError = function throwTypeError() {
  throw new $TypeError();
};
var ThrowTypeError = $gOPD ? function () {
  try {
    arguments.callee;
    return throwTypeError;
  } catch (calleeThrows) {
    try {
      return $gOPD(arguments, 'callee').get;
    } catch (gOPDthrows) {
      return throwTypeError;
    }
  }
}() : throwTypeError;
var hasSymbols$1 = hasSymbols();
var hasProto$1 = hasProto();
var getProto = Object.getPrototypeOf || (hasProto$1 ? function (x) {
  return x.__proto__;
} : null);
var needsEval = {};
var TypedArray = typeof Uint8Array === 'undefined' || !getProto ? undefined$1 : getProto(Uint8Array);
var INTRINSICS = {
  '%AggregateError%': typeof AggregateError === 'undefined' ? undefined$1 : AggregateError,
  '%Array%': Array,
  '%ArrayBuffer%': typeof ArrayBuffer === 'undefined' ? undefined$1 : ArrayBuffer,
  '%ArrayIteratorPrototype%': hasSymbols$1 && getProto ? getProto([][Symbol.iterator]()) : undefined$1,
  '%AsyncFromSyncIteratorPrototype%': undefined$1,
  '%AsyncFunction%': needsEval,
  '%AsyncGenerator%': needsEval,
  '%AsyncGeneratorFunction%': needsEval,
  '%AsyncIteratorPrototype%': needsEval,
  '%Atomics%': typeof Atomics === 'undefined' ? undefined$1 : Atomics,
  '%BigInt%': typeof BigInt === 'undefined' ? undefined$1 : BigInt,
  '%BigInt64Array%': typeof BigInt64Array === 'undefined' ? undefined$1 : BigInt64Array,
  '%BigUint64Array%': typeof BigUint64Array === 'undefined' ? undefined$1 : BigUint64Array,
  '%Boolean%': Boolean,
  '%DataView%': typeof DataView === 'undefined' ? undefined$1 : DataView,
  '%Date%': Date,
  '%decodeURI%': decodeURI,
  '%decodeURIComponent%': decodeURIComponent,
  '%encodeURI%': encodeURI,
  '%encodeURIComponent%': encodeURIComponent,
  '%Error%': Error,
  '%eval%': eval,
  '%EvalError%': EvalError,
  '%Float32Array%': typeof Float32Array === 'undefined' ? undefined$1 : Float32Array,
  '%Float64Array%': typeof Float64Array === 'undefined' ? undefined$1 : Float64Array,
  '%FinalizationRegistry%': typeof FinalizationRegistry === 'undefined' ? undefined$1 : FinalizationRegistry,
  '%Function%': $Function,
  '%GeneratorFunction%': needsEval,
  '%Int8Array%': typeof Int8Array === 'undefined' ? undefined$1 : Int8Array,
  '%Int16Array%': typeof Int16Array === 'undefined' ? undefined$1 : Int16Array,
  '%Int32Array%': typeof Int32Array === 'undefined' ? undefined$1 : Int32Array,
  '%isFinite%': isFinite,
  '%isNaN%': isNaN,
  '%IteratorPrototype%': hasSymbols$1 && getProto ? getProto(getProto([][Symbol.iterator]())) : undefined$1,
  '%JSON%': typeof JSON === 'object' ? JSON : undefined$1,
  '%Map%': typeof Map === 'undefined' ? undefined$1 : Map,
  '%MapIteratorPrototype%': typeof Map === 'undefined' || !hasSymbols$1 || !getProto ? undefined$1 : getProto(new Map()[Symbol.iterator]()),
  '%Math%': Math,
  '%Number%': Number,
  '%Object%': Object,
  '%parseFloat%': parseFloat,
  '%parseInt%': parseInt,
  '%Promise%': typeof Promise === 'undefined' ? undefined$1 : Promise,
  '%Proxy%': typeof Proxy === 'undefined' ? undefined$1 : Proxy,
  '%RangeError%': RangeError,
  '%ReferenceError%': ReferenceError,
  '%Reflect%': typeof Reflect === 'undefined' ? undefined$1 : Reflect,
  '%RegExp%': RegExp,
  '%Set%': typeof Set === 'undefined' ? undefined$1 : Set,
  '%SetIteratorPrototype%': typeof Set === 'undefined' || !hasSymbols$1 || !getProto ? undefined$1 : getProto(new Set()[Symbol.iterator]()),
  '%SharedArrayBuffer%': typeof SharedArrayBuffer === 'undefined' ? undefined$1 : SharedArrayBuffer,
  '%String%': String,
  '%StringIteratorPrototype%': hasSymbols$1 && getProto ? getProto(''[Symbol.iterator]()) : undefined$1,
  '%Symbol%': hasSymbols$1 ? Symbol : undefined$1,
  '%SyntaxError%': $SyntaxError,
  '%ThrowTypeError%': ThrowTypeError,
  '%TypedArray%': TypedArray,
  '%TypeError%': $TypeError,
  '%Uint8Array%': typeof Uint8Array === 'undefined' ? undefined$1 : Uint8Array,
  '%Uint8ClampedArray%': typeof Uint8ClampedArray === 'undefined' ? undefined$1 : Uint8ClampedArray,
  '%Uint16Array%': typeof Uint16Array === 'undefined' ? undefined$1 : Uint16Array,
  '%Uint32Array%': typeof Uint32Array === 'undefined' ? undefined$1 : Uint32Array,
  '%URIError%': URIError,
  '%WeakMap%': typeof WeakMap === 'undefined' ? undefined$1 : WeakMap,
  '%WeakRef%': typeof WeakRef === 'undefined' ? undefined$1 : WeakRef,
  '%WeakSet%': typeof WeakSet === 'undefined' ? undefined$1 : WeakSet
};
if (getProto) {
  try {
    null.error;
  } catch (e) {
    var errorProto = getProto(getProto(e));
    INTRINSICS['%Error.prototype%'] = errorProto;
  }
}
var doEval = function doEval(name) {
  var value;
  if (name === '%AsyncFunction%') {
    value = getEvalledConstructor('async function () {}');
  } else if (name === '%GeneratorFunction%') {
    value = getEvalledConstructor('function* () {}');
  } else if (name === '%AsyncGeneratorFunction%') {
    value = getEvalledConstructor('async function* () {}');
  } else if (name === '%AsyncGenerator%') {
    var fn = doEval('%AsyncGeneratorFunction%');
    if (fn) {
      value = fn.prototype;
    }
  } else if (name === '%AsyncIteratorPrototype%') {
    var gen = doEval('%AsyncGenerator%');
    if (gen && getProto) {
      value = getProto(gen.prototype);
    }
  }
  INTRINSICS[name] = value;
  return value;
};
var LEGACY_ALIASES = {
  '%ArrayBufferPrototype%': ['ArrayBuffer', 'prototype'],
  '%ArrayPrototype%': ['Array', 'prototype'],
  '%ArrayProto_entries%': ['Array', 'prototype', 'entries'],
  '%ArrayProto_forEach%': ['Array', 'prototype', 'forEach'],
  '%ArrayProto_keys%': ['Array', 'prototype', 'keys'],
  '%ArrayProto_values%': ['Array', 'prototype', 'values'],
  '%AsyncFunctionPrototype%': ['AsyncFunction', 'prototype'],
  '%AsyncGenerator%': ['AsyncGeneratorFunction', 'prototype'],
  '%AsyncGeneratorPrototype%': ['AsyncGeneratorFunction', 'prototype', 'prototype'],
  '%BooleanPrototype%': ['Boolean', 'prototype'],
  '%DataViewPrototype%': ['DataView', 'prototype'],
  '%DatePrototype%': ['Date', 'prototype'],
  '%ErrorPrototype%': ['Error', 'prototype'],
  '%EvalErrorPrototype%': ['EvalError', 'prototype'],
  '%Float32ArrayPrototype%': ['Float32Array', 'prototype'],
  '%Float64ArrayPrototype%': ['Float64Array', 'prototype'],
  '%FunctionPrototype%': ['Function', 'prototype'],
  '%Generator%': ['GeneratorFunction', 'prototype'],
  '%GeneratorPrototype%': ['GeneratorFunction', 'prototype', 'prototype'],
  '%Int8ArrayPrototype%': ['Int8Array', 'prototype'],
  '%Int16ArrayPrototype%': ['Int16Array', 'prototype'],
  '%Int32ArrayPrototype%': ['Int32Array', 'prototype'],
  '%JSONParse%': ['JSON', 'parse'],
  '%JSONStringify%': ['JSON', 'stringify'],
  '%MapPrototype%': ['Map', 'prototype'],
  '%NumberPrototype%': ['Number', 'prototype'],
  '%ObjectPrototype%': ['Object', 'prototype'],
  '%ObjProto_toString%': ['Object', 'prototype', 'toString'],
  '%ObjProto_valueOf%': ['Object', 'prototype', 'valueOf'],
  '%PromisePrototype%': ['Promise', 'prototype'],
  '%PromiseProto_then%': ['Promise', 'prototype', 'then'],
  '%Promise_all%': ['Promise', 'all'],
  '%Promise_reject%': ['Promise', 'reject'],
  '%Promise_resolve%': ['Promise', 'resolve'],
  '%RangeErrorPrototype%': ['RangeError', 'prototype'],
  '%ReferenceErrorPrototype%': ['ReferenceError', 'prototype'],
  '%RegExpPrototype%': ['RegExp', 'prototype'],
  '%SetPrototype%': ['Set', 'prototype'],
  '%SharedArrayBufferPrototype%': ['SharedArrayBuffer', 'prototype'],
  '%StringPrototype%': ['String', 'prototype'],
  '%SymbolPrototype%': ['Symbol', 'prototype'],
  '%SyntaxErrorPrototype%': ['SyntaxError', 'prototype'],
  '%TypedArrayPrototype%': ['TypedArray', 'prototype'],
  '%TypeErrorPrototype%': ['TypeError', 'prototype'],
  '%Uint8ArrayPrototype%': ['Uint8Array', 'prototype'],
  '%Uint8ClampedArrayPrototype%': ['Uint8ClampedArray', 'prototype'],
  '%Uint16ArrayPrototype%': ['Uint16Array', 'prototype'],
  '%Uint32ArrayPrototype%': ['Uint32Array', 'prototype'],
  '%URIErrorPrototype%': ['URIError', 'prototype'],
  '%WeakMapPrototype%': ['WeakMap', 'prototype'],
  '%WeakSetPrototype%': ['WeakSet', 'prototype']
};
var $concat = functionBind.call(Function.call, Array.prototype.concat);
var $spliceApply = functionBind.call(Function.apply, Array.prototype.splice);
var $replace = functionBind.call(Function.call, String.prototype.replace);
var $strSlice = functionBind.call(Function.call, String.prototype.slice);
var $exec = functionBind.call(Function.call, RegExp.prototype.exec);
var rePropName = /[^%.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|%$))/g;
var reEscapeChar = /\\(\\)?/g;
var stringToPath = function stringToPath(string) {
  var first = $strSlice(string, 0, 1);
  var last = $strSlice(string, -1);
  if (first === '%' && last !== '%') {
    throw new $SyntaxError('invalid intrinsic syntax, expected closing `%`');
  } else if (last === '%' && first !== '%') {
    throw new $SyntaxError('invalid intrinsic syntax, expected opening `%`');
  }
  var result = [];
  $replace(string, rePropName, function (match, number, quote, subString) {
    result[result.length] = quote ? $replace(subString, reEscapeChar, '$1') : number || match;
  });
  return result;
};
var getBaseIntrinsic = function getBaseIntrinsic(name, allowMissing) {
  var intrinsicName = name;
  var alias;
  if (src(LEGACY_ALIASES, intrinsicName)) {
    alias = LEGACY_ALIASES[intrinsicName];
    intrinsicName = '%' + alias[0] + '%';
  }
  if (src(INTRINSICS, intrinsicName)) {
    var value = INTRINSICS[intrinsicName];
    if (value === needsEval) {
      value = doEval(intrinsicName);
    }
    if (typeof value === 'undefined' && !allowMissing) {
      throw new $TypeError('intrinsic ' + name + ' exists, but is not available. Please file an issue!');
    }
    return {
      alias: alias,
      name: intrinsicName,
      value: value
    };
  }
  throw new $SyntaxError('intrinsic ' + name + ' does not exist!');
};
var getIntrinsic = function GetIntrinsic(name, allowMissing) {
  if (typeof name !== 'string' || name.length === 0) {
    throw new $TypeError('intrinsic name must be a non-empty string');
  }
  if (arguments.length > 1 && typeof allowMissing !== 'boolean') {
    throw new $TypeError('"allowMissing" argument must be a boolean');
  }
  if ($exec(/^%?[^%]*%?$/, name) === null) {
    throw new $SyntaxError('`%` may not be present anywhere but at the beginning and end of the intrinsic name');
  }
  var parts = stringToPath(name);
  var intrinsicBaseName = parts.length > 0 ? parts[0] : '';
  var intrinsic = getBaseIntrinsic('%' + intrinsicBaseName + '%', allowMissing);
  var intrinsicRealName = intrinsic.name;
  var value = intrinsic.value;
  var skipFurtherCaching = false;
  var alias = intrinsic.alias;
  if (alias) {
    intrinsicBaseName = alias[0];
    $spliceApply(parts, $concat([0, 1], alias));
  }
  for (var i = 1, isOwn = true; i < parts.length; i += 1) {
    var part = parts[i];
    var first = $strSlice(part, 0, 1);
    var last = $strSlice(part, -1);
    if ((first === '"' || first === "'" || first === '`' || last === '"' || last === "'" || last === '`') && first !== last) {
      throw new $SyntaxError('property names with quotes must have matching quotes');
    }
    if (part === 'constructor' || !isOwn) {
      skipFurtherCaching = true;
    }
    intrinsicBaseName += '.' + part;
    intrinsicRealName = '%' + intrinsicBaseName + '%';
    if (src(INTRINSICS, intrinsicRealName)) {
      value = INTRINSICS[intrinsicRealName];
    } else if (value != null) {
      if (!(part in value)) {
        if (!allowMissing) {
          throw new $TypeError('base intrinsic for ' + name + ' exists, but the property is not available.');
        }
        return void undefined$1;
      }
      if ($gOPD && i + 1 >= parts.length) {
        var desc = $gOPD(value, part);
        isOwn = !!desc;
        if (isOwn && 'get' in desc && !('originalValue' in desc.get)) {
          value = desc.get;
        } else {
          value = value[part];
        }
      } else {
        isOwn = src(value, part);
        value = value[part];
      }
      if (isOwn && !skipFurtherCaching) {
        INTRINSICS[intrinsicRealName] = value;
      }
    }
  }
  return value;
};

var callBind = createCommonjsModule(function (module) {

  var $apply = getIntrinsic('%Function.prototype.apply%');
  var $call = getIntrinsic('%Function.prototype.call%');
  var $reflectApply = getIntrinsic('%Reflect.apply%', true) || functionBind.call($call, $apply);
  var $gOPD = getIntrinsic('%Object.getOwnPropertyDescriptor%', true);
  var $defineProperty = getIntrinsic('%Object.defineProperty%', true);
  var $max = getIntrinsic('%Math.max%');
  if ($defineProperty) {
    try {
      $defineProperty({}, 'a', {
        value: 1
      });
    } catch (e) {
      $defineProperty = null;
    }
  }
  module.exports = function callBind(originalFunction) {
    var func = $reflectApply(functionBind, $call, arguments);
    if ($gOPD && $defineProperty) {
      var desc = $gOPD(func, 'length');
      if (desc.configurable) {
        $defineProperty(func, 'length', {
          value: 1 + $max(0, originalFunction.length - (arguments.length - 1))
        });
      }
    }
    return func;
  };
  var applyBind = function applyBind() {
    return $reflectApply(functionBind, $apply, arguments);
  };
  if ($defineProperty) {
    $defineProperty(module.exports, 'apply', {
      value: applyBind
    });
  } else {
    module.exports.apply = applyBind;
  }
});

var $indexOf = callBind(getIntrinsic('String.prototype.indexOf'));
var callBound = function callBoundIntrinsic(name, allowMissing) {
  var intrinsic = getIntrinsic(name, !!allowMissing);
  if (typeof intrinsic === 'function' && $indexOf(name, '.prototype.') > -1) {
    return callBind(intrinsic);
  }
  return intrinsic;
};

var $TypeError$1 = getIntrinsic('%TypeError%');
var $WeakMap = getIntrinsic('%WeakMap%', true);
var $Map = getIntrinsic('%Map%', true);
var $weakMapGet = callBound('WeakMap.prototype.get', true);
var $weakMapSet = callBound('WeakMap.prototype.set', true);
var $weakMapHas = callBound('WeakMap.prototype.has', true);
var $mapGet = callBound('Map.prototype.get', true);
var $mapSet = callBound('Map.prototype.set', true);
var $mapHas = callBound('Map.prototype.has', true);

var hexTable = function () {
  var array = [];
  for (var i = 0; i < 256; ++i) {
    array.push('%' + ((i < 16 ? '0' : '') + i.toString(16)).toUpperCase());
  }
  return array;
}();

var request = axios.create();
request.interceptors.request.use(function (config) {
  return config;
}, function (error) {
  return Promise.reject(error.response || {
    data: {}
  });
});
request.interceptors.response.use(function (response) {
  return response;
}, function (error) {
  return Promise.reject((error === null || error === void 0 ? void 0 : error.response) || {
    data: {}
  });
});
var requestOther = axios.create();
requestOther.interceptors.request.use(function (config) {
  return config;
}, function (error) {
  return Promise.reject(error.response || {
    data: {}
  });
});
requestOther.interceptors.response.use(function (response) {
  return response;
}, function (error) {
  return Promise.reject((error === null || error === void 0 ? void 0 : error.response) || {
    data: {}
  });
});

var styles$1 = {"chat-file-item":"_2X3uH","chat-file-item-img":"_329j9","chat-file-item-delete":"_ppteR"};

var styleFrom = {
  backgroundColor: '#f1f1f1',
  color: '#000',
  justifyContent: 'flex-start',
  margin: '6px 48px 6px 12px'
};
var styleMe = {
  backgroundColor: '#136DFB',
  color: '#fff',
  justifyContent: 'flex-end',
  margin: '6px 12px 6px 48px'
};
var FbConversationDetail = function FbConversationDetail(props) {
  var _props$style = props.style,
    style = _props$style === void 0 ? {} : _props$style,
    _props$messageStyle = props.messageStyle,
    messageStyle = _props$messageStyle === void 0 ? {} : _props$messageStyle,
    shopId = props.shopId,
    pageId = props.pageId,
    conversation = props.conversation,
    _props$actionGetFbCon = props.actionGetFbConversationDetail,
    actionGetFbConversationDetail = _props$actionGetFbCon === void 0 ? function () {} : _props$actionGetFbCon,
    _props$type = props.type,
    type = _props$type === void 0 ? CONST.CONVERSATION_TYPE.MESSENGER : _props$type,
    _props$showChatHeader = props.showChatHeader,
    showChatHeader = _props$showChatHeader === void 0 ? false : _props$showChatHeader,
    _props$tag = props.tag,
    tag = _props$tag === void 0 ? [] : _props$tag,
    _props$socket = props.socket,
    socket = _props$socket === void 0 ? null : _props$socket,
    _props$actionSendMess = props.actionSendMessage,
    actionSendMessage = _props$actionSendMess === void 0 ? function () {} : _props$actionSendMess,
    _props$actionGetShopC = props.actionGetShopCustomer,
    actionGetShopCustomer = _props$actionGetShopC === void 0 ? function () {} : _props$actionGetShopC,
    _props$fileMaxHeight = props.fileMaxHeight,
    fileMaxHeight = _props$fileMaxHeight === void 0 ? 250 : _props$fileMaxHeight;
  var messagesRef = React.useRef(null);
  var fileInputRef = React.useRef();
  var _useState = React.useState({
      next: 'init'
    }),
    messagePaging = _useState[0],
    setMessagePaging = _useState[1];
  var _useState2 = React.useState(false),
    fetchingData = _useState2[0],
    setFetchingData = _useState2[1];
  var _useState3 = React.useState(10),
    startIndex = _useState3[0];
  var _useState4 = React.useState(true),
    firstFetchingMessages = _useState4[0],
    setFirstFetchingMessages = _useState4[1];
  var _useState5 = React.useState({
      shopId: shopId,
      conversationId: 0,
      pageId: pageId
    }),
    conversationDetailParams = _useState5[0],
    setConversationDetailParams = _useState5[1];
  var _useState6 = React.useState(),
    conversationDetail = _useState6[0],
    setConversationDetail = _useState6[1];
  var _useState7 = React.useState([]),
    messages = _useState7[0],
    setMessages = _useState7[1];
  var _useState8 = React.useState(),
    shopCustomer = _useState8[0],
    setShopCustomer = _useState8[1];
  var _useState9 = React.useState(false),
    isChatSending = _useState9[0],
    setIsChatSending = _useState9[1];
  var _useState10 = React.useState(''),
    chatContent = _useState10[0],
    setChatContent = _useState10[1];
  var _useState11 = React.useState([]),
    files = _useState11[0],
    setFiles = _useState11[1];
  React.useEffect(function () {
    handleConversation();
  }, [conversation]);
  React.useEffect(function () {
    getConversationDetail();
  }, [conversationDetailParams]);
  React.useEffect(function () {
    if (socket) {
      socket.on('webhook_facebook', handleWebhookMessage);
    }
  }, [socket]);
  var handleConversation = function handleConversation() {
    var _conversation$partici, _conversation$partici2;
    var partner = conversation === null || conversation === void 0 ? void 0 : (_conversation$partici = conversation.participants) === null || _conversation$partici === void 0 ? void 0 : (_conversation$partici2 = _conversation$partici.data) === null || _conversation$partici2 === void 0 ? void 0 : _conversation$partici2[0];
    var displayName = (partner === null || partner === void 0 ? void 0 : partner.name) || '';
    var displayAvatar = (partner === null || partner === void 0 ? void 0 : partner.urlAvatar) || '';
    var fbChatUserId = (partner === null || partner === void 0 ? void 0 : partner.id) || '';
    var chatId = (conversation === null || conversation === void 0 ? void 0 : conversation.id) || '';
    var _conversation = _extends({
      displayName: displayName,
      displayAvatar: displayAvatar,
      message: (conversation === null || conversation === void 0 ? void 0 : conversation.message) || '',
      time: (conversation === null || conversation === void 0 ? void 0 : conversation.updated_time) || 0,
      chatId: chatId,
      fbChatUserId: fbChatUserId
    }, conversation);
    setMessagePaging({
      next: 'init'
    });
    setFirstFetchingMessages(true);
    setConversationDetail(_conversation);
    setConversationDetailParams(_extends({}, conversationDetailParams, {
      conversationId: _conversation === null || _conversation === void 0 ? void 0 : _conversation.chatId,
      pageId: pageId,
      after: null
    }));
    console.log('_conversation -----> ', _conversation);
    getShopCustomer(_conversation === null || _conversation === void 0 ? void 0 : _conversation.fbChatUserId);
  };
  var getConversationDetail = function getConversationDetail() {
    try {
      var _temp = function () {
        if (conversationDetail !== null && conversationDetail !== void 0 && conversationDetail.chatId && (!messagePaging || messagePaging !== null && messagePaging !== void 0 && messagePaging.next) && !fetchingData) {
          setFetchingData(true);
          return Promise.resolve(actionGetFbConversationDetail(conversationDetailParams)).then(function (res) {
            var _res$data, _res$data$data, _res$data2, _res$data2$data;
            console.log('getConversationDetail', res);
            var _messages = (res === null || res === void 0 ? void 0 : (_res$data = res.data) === null || _res$data === void 0 ? void 0 : (_res$data$data = _res$data.data) === null || _res$data$data === void 0 ? void 0 : _res$data$data.data) || [];
            _messages.reverse();
            _messages = _messages.map(function (e) {
              return _extends({}, e, {
                style: (e === null || e === void 0 ? void 0 : e.fromId) === (conversationDetail === null || conversationDetail === void 0 ? void 0 : conversationDetail.fbChatUserId) ? styleFrom : styleMe
              });
            });
            if (conversationDetailParams !== null && conversationDetailParams !== void 0 && conversationDetailParams.after) {
              setMessages([].concat(_messages, messages));
            } else {
              setMessages(_messages);
            }
            var paging = res === null || res === void 0 ? void 0 : (_res$data2 = res.data) === null || _res$data2 === void 0 ? void 0 : (_res$data2$data = _res$data2.data) === null || _res$data2$data === void 0 ? void 0 : _res$data2$data.paging;
            setMessagePaging(paging);
            setFetchingData(false);
            setFirstFetchingMessages(false);
          });
        }
      }();
      return Promise.resolve(_temp && _temp.then ? _temp.then(function () {}) : void 0);
    } catch (e) {
      return Promise.reject(e);
    }
  };
  var startReached = function startReached() {
    var _messagePaging$cursor;
    setConversationDetailParams(_extends({}, conversationDetailParams, {
      after: (_messagePaging$cursor = messagePaging.cursors) === null || _messagePaging$cursor === void 0 ? void 0 : _messagePaging$cursor.after
    }));
  };
  var getShopCustomer = function getShopCustomer(fbChatUserId) {
    try {
      return Promise.resolve(actionGetShopCustomer({
        shopId: shopId,
        pageId: pageId,
        userId: fbChatUserId
      })).then(function (res) {
        var _res$data3;
        setShopCustomer(res === null || res === void 0 ? void 0 : (_res$data3 = res.data) === null || _res$data3 === void 0 ? void 0 : _res$data3.data);
      });
    } catch (e) {
      return Promise.reject(e);
    }
  };
  var sendMessage = function sendMessage() {
    try {
      var formData = new FormData();
      files.forEach(function (e) {
        formData.append("files", e);
      });
      formData.append("message", chatContent || '');
      formData.append("customerId", shopCustomer === null || shopCustomer === void 0 ? void 0 : shopCustomer.customerId);
      formData.append("shopId", shopId);
      formData.append("pageId", pageId);
      var _temp2 = function () {
        if (chatContent || files !== null && files !== void 0 && files.length) {
          setIsChatSending(true);
          setChatContent('');
          setFiles([]);
          return Promise.resolve(actionSendMessage(null, formData)).then(function () {});
        }
      }();
      return Promise.resolve(_temp2 && _temp2.then ? _temp2.then(function () {}) : void 0);
    } catch (e) {
      return Promise.reject(e);
    }
  };
  var handleWebhookMessage = function handleWebhookMessage(event) {
    console.log('webhook_facebook', event);
    setMessages(function (messages) {
      var attachments = null;
      if (event !== null && event !== void 0 && event.attachments) {
        var data = event === null || event === void 0 ? void 0 : event.attachments.map(function (e) {
          return _extends({}, e, {
            image_data: {
              preview_url: e === null || e === void 0 ? void 0 : e.preview_url
            }
          });
        });
        attachments = {
          data: data
        };
        console.log('attachments', attachments);
      }
      var newMessage = _extends({}, event, {
        attachments: attachments,
        id: event === null || event === void 0 ? void 0 : event.mid,
        created_time: event === null || event === void 0 ? void 0 : event.createdTime,
        style: (event === null || event === void 0 ? void 0 : event.toId) === pageId ? styleFrom : styleMe
      });
      console.log('newMessage', newMessage);
      return [].concat(messages, [newMessage]);
    });
    setIsChatSending(false);
  };
  var handleChange = function handleChange(event) {
    var _event$target, _event$target2;
    console.log('files', (_event$target = event.target) === null || _event$target === void 0 ? void 0 : _event$target.files);
    setFiles(Array.from((_event$target2 = event.target) === null || _event$target2 === void 0 ? void 0 : _event$target2.files));
  };
  var removeFileItem = function removeFileItem(item, index) {
    files.splice(index, 1);
    setFiles([].concat(files));
  };
  return /*#__PURE__*/React__default.createElement("div", {
    style: _extends({
      flex: 1,
      display: 'flex',
      flexDirection: 'column',
      minWidth: 300,
      height: '100%'
    }, style)
  }, showChatHeader ? /*#__PURE__*/React__default.createElement("div", {
    style: {
      padding: 12,
      height: 64,
      width: '100%'
    },
    className: "box-shadow"
  }, /*#__PURE__*/React__default.createElement("div", {
    style: {
      display: 'inline-flex',
      alignItems: 'center'
    }
  }, /*#__PURE__*/React__default.createElement("img", {
    src: conversationDetail === null || conversationDetail === void 0 ? void 0 : conversationDetail.displayAvatar,
    style: {
      width: 40,
      height: 40,
      borderRadius: 20,
      objectFit: 'cover',
      backgroundColor: '#f1f1f1'
    }
  }), /*#__PURE__*/React__default.createElement("div", {
    style: {
      marginLeft: 12
    }
  }, /*#__PURE__*/React__default.createElement("div", null, conversationDetail === null || conversationDetail === void 0 ? void 0 : conversationDetail.displayName), /*#__PURE__*/React__default.createElement(antd.Space, {
    size: 0,
    style: {
      marginTop: 4
    }
  }, tag === null || tag === void 0 ? void 0 : tag.map(function (e) {
    return /*#__PURE__*/React__default.createElement(antd.Tag, {
      color: e === null || e === void 0 ? void 0 : e.color
    }, e === null || e === void 0 ? void 0 : e.name);
  }))))) : null, firstFetchingMessages && !(conversationDetailParams !== null && conversationDetailParams !== void 0 && conversationDetailParams.page) ? /*#__PURE__*/React__default.createElement("div", {
    style: {
      flex: 1,
      padding: 24
    }
  }, /*#__PURE__*/React__default.createElement(antd.Skeleton, {
    loading: true,
    active: true,
    avatar: true
  }), /*#__PURE__*/React__default.createElement(antd.Skeleton, {
    loading: true,
    active: true,
    avatar: true
  }), /*#__PURE__*/React__default.createElement(antd.Skeleton, {
    loading: true,
    active: true,
    avatar: true
  })) : /*#__PURE__*/React__default.createElement(React.Fragment, null, /*#__PURE__*/React__default.createElement(MessagesRender, {
    ref: messagesRef,
    messages: messages,
    startReached: startReached,
    START_INDEX: startIndex,
    type: type,
    isChatSending: isChatSending,
    messageStyle: messageStyle
  }), isChatSending ? /*#__PURE__*/React__default.createElement("div", {
    style: {
      color: '#999',
      fontSize: 12,
      textAlign: 'center',
      padding: 4
    }
  }, "\u0110ang g\u1EEDi") : null, /*#__PURE__*/React__default.createElement("div", {
    style: {
      maxHeight: fileMaxHeight,
      overflowY: 'auto',
      borderTop: '1px solid #eee'
    }
  }, files === null || files === void 0 ? void 0 : files.map(function (e, i) {
    return /*#__PURE__*/React__default.createElement("div", {
      key: e === null || e === void 0 ? void 0 : e.name,
      className: styles$1['chat-file-item']
    }, /*#__PURE__*/React__default.createElement("div", {
      className: styles$1['chat-file-item-img']
    }, (e === null || e === void 0 ? void 0 : e.type.indexOf('image')) > -1 ? /*#__PURE__*/React__default.createElement(FileImageOutlined$2, null) : /*#__PURE__*/React__default.createElement(PaperClipOutlined$2, null)), /*#__PURE__*/React__default.createElement("div", {
      style: {
        flex: 1,
        marginLeft: 12
      }
    }, e === null || e === void 0 ? void 0 : e.name), /*#__PURE__*/React__default.createElement(CloseOutlined$2, {
      className: styles$1['chat-file-item-delete'],
      onClick: function onClick() {
        return removeFileItem(e, i);
      }
    }));
  })), /*#__PURE__*/React__default.createElement("div", {
    style: {
      padding: 8,
      display: 'flex',
      flexDirection: 'row',
      alignItems: 'flex-end'
    }
  }, /*#__PURE__*/React__default.createElement(antd.Input.TextArea, {
    placeholder: "Nh\u1EADp n\u1ED9i dung",
    value: chatContent,
    onChange: function onChange(e) {
      var _e$target;
      return setChatContent(e === null || e === void 0 ? void 0 : (_e$target = e.target) === null || _e$target === void 0 ? void 0 : _e$target.value);
    },
    autoSize: {
      minRows: 1,
      maxRows: 6
    },
    style: {
      flex: 1
    }
  }), /*#__PURE__*/React__default.createElement(PaperClipOutlined$2, {
    style: {
      fontSize: 24,
      paddingLeft: 12,
      paddingBottom: 4,
      color: '#136DFB'
    },
    onClick: function onClick() {
      return fileInputRef.current.click();
    }
  }), /*#__PURE__*/React__default.createElement("input", {
    onChange: handleChange,
    multiple: true,
    ref: fileInputRef,
    type: "file",
    hidden: true
  }), /*#__PURE__*/React__default.createElement(SendOutlined$2, {
    style: {
      fontSize: 24,
      paddingLeft: 12,
      paddingBottom: 4,
      color: '#136DFB'
    },
    onClick: sendMessage
  }))));
};

var ZaloConversations = function ZaloConversations(props) {
  var shopId = props.shopId,
    _props$actionGetListC = props.actionGetListConversation,
    actionGetListConversation = _props$actionGetListC === void 0 ? function () {} : _props$actionGetListC,
    _props$onSelectConver = props.onSelectConversation,
    onSelectConversation = _props$onSelectConver === void 0 ? function () {} : _props$onSelectConver,
    _props$fetchingDone = props.fetchingDone,
    fetchingDone = _props$fetchingDone === void 0 ? function () {} : _props$fetchingDone,
    _props$tags = props.tags,
    tags = _props$tags === void 0 ? {} : _props$tags,
    _props$socket = props.socket,
    socket = _props$socket === void 0 ? null : _props$socket;
  var _useState = React.useState(true),
    fetchingConversations = _useState[0],
    setFetchingConversations = _useState[1];
  var _useState2 = React.useState(false),
    loadConversations = _useState2[0],
    setLoadConversations = _useState2[1];
  var _useState3 = React.useState(),
    conversation = _useState3[0],
    setConversation = _useState3[1];
  var _useState4 = React.useState([]),
    conversations = _useState4[0],
    setConversations = _useState4[1];
  var _useState5 = React.useState(true),
    isNextPageConversations = _useState5[0],
    setIsNextPageConversations = _useState5[1];
  var _useState6 = React.useState({
      shopId: shopId,
      page: 0,
      pageSize: 10
    }),
    conversationsParams = _useState6[0],
    setConversationsParams = _useState6[1];
  var _useState7 = React.useState(true),
    setIsNextPage = _useState7[1];
  React.useEffect(function () {
    getListConversation();
  }, [conversationsParams]);
  React.useEffect(function () {
    console.log('useEffect socket', socket);
    if (socket !== null && socket !== void 0 && socket.id && socket !== null && socket !== void 0 && socket.connected) {
      socket.on(CONST.EVENT.WEBHOOK_ZALO, function (event) {
        console.log('socket WEBHOOK_ZALO');
        handleWebhookMessage(event);
      });
    }
  }, [socket]);
  var getListConversation = function getListConversation() {
    try {
      setLoadConversations(true);
      return Promise.resolve(actionGetListConversation(conversationsParams)).then(function (res) {
        var _res$data, _res$data$data;
        console.log('actionGetListConversation', res);
        var resDatas = (res === null || res === void 0 ? void 0 : (_res$data = res.data) === null || _res$data === void 0 ? void 0 : (_res$data$data = _res$data.data) === null || _res$data$data === void 0 ? void 0 : _res$data$data.data) || [];
        var _conversations = [];
        if ((resDatas === null || resDatas === void 0 ? void 0 : resDatas.length) < conversationsParams.pageSize) {
          setIsNextPageConversations(false);
        }
        resDatas.forEach(function (e) {
          var displayName = (e === null || e === void 0 ? void 0 : e.to_display_name) || '';
          var displayAvatar = (e === null || e === void 0 ? void 0 : e.to_avatar) || '';
          var chatId = (e === null || e === void 0 ? void 0 : e.to_id) || '';
          if (e !== null && e !== void 0 && e.src) {
            displayName = (e === null || e === void 0 ? void 0 : e.from_display_name) || '';
            displayAvatar = (e === null || e === void 0 ? void 0 : e.from_avatar) || '';
            chatId = (e === null || e === void 0 ? void 0 : e.from_id) || '';
          }
          _conversations.push({
            displayName: displayName,
            displayAvatar: displayAvatar,
            message: (e === null || e === void 0 ? void 0 : e.message) || '',
            time: (e === null || e === void 0 ? void 0 : e.time) || 0,
            chatId: chatId
          });
        });
        if (conversationsParams.page > 0) {
          setConversations([].concat(conversations, _conversations));
        } else {
          setConversations(_conversations);
          selectConversation(_conversations === null || _conversations === void 0 ? void 0 : _conversations[0]);
        }
        setLoadConversations(false);
        setFetchingConversations(false);
        fetchingDone(_conversations);
      });
    } catch (e) {
      return Promise.reject(e);
    }
  };
  var selectConversation = function selectConversation(_conversation) {
    console.log('_conversation', _conversation);
    if ((_conversation === null || _conversation === void 0 ? void 0 : _conversation.chatId) !== (conversation === null || conversation === void 0 ? void 0 : conversation.chatId)) {
      setIsNextPage(true);
      setConversation(_conversation);
      onSelectConversation(_conversation);
    }
  };
  var handleScroll = function handleScroll(event) {
    var scrollTop = event.currentTarget.scrollTop;
    var scrollHeight = event.currentTarget.scrollHeight;
    var offsetHeight = event.currentTarget.offsetHeight;
    var scrollBottom = scrollHeight - offsetHeight - scrollTop;
    if (scrollBottom < 50 && !loadConversations) {
      console.log('bottom');
      if (isNextPageConversations) {
        setConversationsParams(_extends({}, conversationsParams, {
          page: conversationsParams.page + 1
        }));
      }
    }
  };
  var handleWebhookMessage = function handleWebhookMessage(event) {
    var _event$sender, _event$recipient, _event$message7;
    console.log(CONST.EVENT.WEBHOOK_ZALO, event);
    var eventName = event === null || event === void 0 ? void 0 : event.event_name;
    var chatId = eventName.indexOf('user') > -1 ? event === null || event === void 0 ? void 0 : (_event$sender = event.sender) === null || _event$sender === void 0 ? void 0 : _event$sender.id : event === null || event === void 0 ? void 0 : (_event$recipient = event.recipient) === null || _event$recipient === void 0 ? void 0 : _event$recipient.id;
    console.log('conversation', conversation);
    console.log('conversations', conversations);
    console.log('chatId', chatId);
    var buildConversation = {
      message: event === null || event === void 0 ? void 0 : (_event$message7 = event.message) === null || _event$message7 === void 0 ? void 0 : _event$message7.text,
      time: event === null || event === void 0 ? void 0 : event.timestamp
    };
    var index = conversations.findIndex(function (e) {
      return (e === null || e === void 0 ? void 0 : e.chatId) === chatId;
    });
    console.log('index', index);
    if (index > -1) {
      var insert = conversations === null || conversations === void 0 ? void 0 : conversations.splice(index, 1);
      insert = _extends({}, insert, buildConversation);
      console.log('data', index, insert);
      setConversations([insert].concat(conversations));
    }
  };
  return fetchingConversations ? /*#__PURE__*/React__default.createElement("div", {
    style: {
      padding: 24
    }
  }, /*#__PURE__*/React__default.createElement(antd.Skeleton, {
    loading: true,
    active: true,
    avatar: true
  }), /*#__PURE__*/React__default.createElement(antd.Skeleton, {
    loading: true,
    active: true,
    avatar: true
  }), /*#__PURE__*/React__default.createElement(antd.Skeleton, {
    loading: true,
    active: true,
    avatar: true
  })) : /*#__PURE__*/React__default.createElement("div", {
    onScroll: handleScroll,
    style: {
      display: 'flex',
      flexFlow: 'column',
      overflowY: 'auto',
      marginLeft: 12,
      marginTop: 12
    }
  }, conversations === null || conversations === void 0 ? void 0 : conversations.map(function (e, i) {
    var _moment$fromNow, _moment$fromNow$repla, _tags$e$chatId;
    return /*#__PURE__*/React__default.createElement("div", {
      style: {
        display: 'inline-flex',
        padding: 12,
        cursor: 'pointer',
        borderRadius: 6,
        marginRight: 6,
        backgroundColor: (e === null || e === void 0 ? void 0 : e.chatId) === (conversation === null || conversation === void 0 ? void 0 : conversation.chatId) ? '#f1f1f1' : 'transparent'
      },
      onClick: function onClick() {
        return selectConversation(e);
      },
      key: i
    }, /*#__PURE__*/React__default.createElement("img", {
      src: e === null || e === void 0 ? void 0 : e.displayAvatar,
      style: {
        width: 40,
        height: 40,
        borderRadius: 20,
        objectFit: 'cover',
        backgroundColor: '#f1f1f1'
      }
    }), /*#__PURE__*/React__default.createElement("div", {
      style: {
        marginLeft: 12
      }
    }, /*#__PURE__*/React__default.createElement("div", null, e === null || e === void 0 ? void 0 : e.displayName, " 123"), /*#__PURE__*/React__default.createElement("div", {
      style: {
        display: 'flex',
        flexDirection: 'row',
        alignItems: 'center',
        fontSize: 12,
        color: '#999',
        marginTop: 2
      }
    }, e !== null && e !== void 0 && e.message ? /*#__PURE__*/React__default.createElement(React.Fragment, null, /*#__PURE__*/React__default.createElement("div", {
      style: {
        maxWidth: 120,
        'white-space': 'nowrap',
        'text-overflow': 'ellipsis',
        overflow: 'hidden'
      }
    }, e === null || e === void 0 ? void 0 : e.message), /*#__PURE__*/React__default.createElement("div", {
      style: {
        width: 2,
        height: 2,
        backgroundColor: '#ccc',
        borderRadius: 2,
        margin: '0px 4px'
      }
    })) : null, /*#__PURE__*/React__default.createElement("div", null, (_moment$fromNow = moment(e === null || e === void 0 ? void 0 : e.time).fromNow()) === null || _moment$fromNow === void 0 ? void 0 : (_moment$fromNow$repla = _moment$fromNow.replace('trước', '')) === null || _moment$fromNow$repla === void 0 ? void 0 : _moment$fromNow$repla.trim())), /*#__PURE__*/React__default.createElement(antd.Space, {
      size: 0,
      style: {
        marginTop: 4
      }
    }, tags === null || tags === void 0 ? void 0 : (_tags$e$chatId = tags[e === null || e === void 0 ? void 0 : e.chatId]) === null || _tags$e$chatId === void 0 ? void 0 : _tags$e$chatId.map(function (e) {
      return /*#__PURE__*/React__default.createElement(antd.Tag, {
        color: e === null || e === void 0 ? void 0 : e.color
      }, e === null || e === void 0 ? void 0 : e.name);
    }))));
  }));
};

var styleFrom$1 = {
  backgroundColor: '#f1f1f1',
  color: '#000',
  justifyContent: 'flex-start',
  margin: '6px 48px 6px 12px'
};
var styleMe$1 = {
  backgroundColor: '#136DFB',
  color: '#fff',
  justifyContent: 'flex-end',
  margin: '6px 12px 6px 48px'
};
var ZaloConversationDetail = function ZaloConversationDetail(props) {
  var _props$style = props.style,
    style = _props$style === void 0 ? {} : _props$style,
    shopId = props.shopId,
    _props$showChatHeader = props.showChatHeader,
    showChatHeader = _props$showChatHeader === void 0 ? false : _props$showChatHeader,
    conversation = props.conversation,
    _props$actionGetConve = props.actionGetConversationDetail,
    actionGetConversationDetail = _props$actionGetConve === void 0 ? function () {} : _props$actionGetConve,
    _props$tag = props.tag,
    tag = _props$tag === void 0 ? [] : _props$tag,
    _props$actionSendMess = props.actionSendMessage,
    actionSendMessage = _props$actionSendMess === void 0 ? function () {} : _props$actionSendMess,
    _props$actionGetShopC = props.actionGetShopCustomerByChatId,
    actionGetShopCustomerByChatId = _props$actionGetShopC === void 0 ? function () {} : _props$actionGetShopC;
  var messagesRef = React.useRef(null);
  var _useState = React.useState({
      next: 'init'
    });
  var _useState2 = React.useState(false),
    fetchingData = _useState2[0],
    setFetchingData = _useState2[1];
  var _useState3 = React.useState(10),
    startIndex = _useState3[0],
    setStartIndex = _useState3[1];
  var _useState4 = React.useState(true);
  var _useState5 = React.useState({
      shopId: shopId,
      page: 0,
      pageSize: 10
    }),
    conversationDetailParams = _useState5[0],
    setConversationDetailParams = _useState5[1];
  var _useState6 = React.useState(),
    conversationDetail = _useState6[0],
    setConversationDetail = _useState6[1];
  var _useState7 = React.useState([]),
    messages = _useState7[0],
    setMessages = _useState7[1];
  var _useState8 = React.useState(true),
    isNextPage = _useState8[0],
    setIsNextPage = _useState8[1];
  var _useState9 = React.useState(),
    shopCustomer = _useState9[0],
    setShopCustomer = _useState9[1];
  var _useState10 = React.useState(''),
    chatContent = _useState10[0],
    setChatContent = _useState10[1];
  React.useEffect(function () {
    handleConversation();
  }, [conversation]);
  React.useEffect(function () {
    getConversationDetail();
  }, [conversationDetailParams]);
  var handleConversation = function handleConversation() {
    var displayName = (conversation === null || conversation === void 0 ? void 0 : conversation.to_display_name) || '';
    var displayAvatar = (conversation === null || conversation === void 0 ? void 0 : conversation.to_avatar) || '';
    var chatId = (conversation === null || conversation === void 0 ? void 0 : conversation.to_id) || '';
    if (conversation !== null && conversation !== void 0 && conversation.src) {
      displayName = (conversation === null || conversation === void 0 ? void 0 : conversation.from_display_name) || '';
      displayAvatar = (conversation === null || conversation === void 0 ? void 0 : conversation.from_avatar) || '';
      chatId = (conversation === null || conversation === void 0 ? void 0 : conversation.from_id) || '';
    }
    var _conversation = _extends({
      displayName: displayName,
      displayAvatar: displayAvatar,
      message: (conversation === null || conversation === void 0 ? void 0 : conversation.message) || '',
      time: (conversation === null || conversation === void 0 ? void 0 : conversation.time) || 0,
      chatId: chatId
    }, conversation);
    setIsNextPage(true);
    setConversationDetail(_conversation);
    setConversationDetailParams(_extends({}, conversationDetailParams, {
      page: 0,
      userOAId: _conversation === null || _conversation === void 0 ? void 0 : _conversation.chatId
    }));
    getShopCustomer(_conversation === null || _conversation === void 0 ? void 0 : _conversation.chatId);
  };
  var getConversationDetail = function getConversationDetail() {
    try {
      var _temp = function () {
        if (conversationDetail !== null && conversationDetail !== void 0 && conversationDetail.chatId && isNextPage) {
          setFetchingData(true);
          console.log('conversationDetailParams', conversationDetailParams);
          return Promise.resolve(actionGetConversationDetail(conversationDetailParams)).then(function (res) {
            var _res$data, _messages2;
            console.log('getConversationDetail', res);
            var _messages = (res === null || res === void 0 ? void 0 : (_res$data = res.data) === null || _res$data === void 0 ? void 0 : _res$data.data) || [];
            if (((_messages2 = _messages) === null || _messages2 === void 0 ? void 0 : _messages2.length) < 10) {
              setIsNextPage(false);
            }
            _messages.reverse();
            _messages = _messages.map(function (e) {
              return _extends({}, e, {
                style: e !== null && e !== void 0 && e.src ? styleFrom$1 : styleMe$1
              });
            });
            console.log('_messages', _messages);
            if (conversationDetailParams !== null && conversationDetailParams !== void 0 && conversationDetailParams.page) {
              setMessages([].concat(_messages, messages));
            } else {
              var _messages3;
              setMessages(_messages);
              setStartIndex((_messages3 = _messages) === null || _messages3 === void 0 ? void 0 : _messages3.length);
            }
            setFetchingData(false);
          });
        }
      }();
      return Promise.resolve(_temp && _temp.then ? _temp.then(function () {}) : void 0);
    } catch (e) {
      return Promise.reject(e);
    }
  };
  var startReached = function startReached() {
    if (!fetchingData) {
      setConversationDetailParams(_extends({}, conversationDetailParams, {
        page: conversationDetailParams.page + 1
      }));
    }
  };
  var getShopCustomer = function getShopCustomer(chatId) {
    try {
      console.log('getShopCustomer', chatId);
      return Promise.resolve(actionGetShopCustomerByChatId(shopId, chatId)).then(function (res) {
        var _res$data2;
        setShopCustomer(res === null || res === void 0 ? void 0 : (_res$data2 = res.data) === null || _res$data2 === void 0 ? void 0 : _res$data2.data);
      });
    } catch (e) {
      return Promise.reject(e);
    }
  };
  var sendMessage = function sendMessage() {
    try {
      var params = {
        customerId: shopCustomer === null || shopCustomer === void 0 ? void 0 : shopCustomer.customerId,
        message: chatContent,
        shopId: shopId,
        type: 'MESSAGE'
      };
      return Promise.resolve(actionSendMessage(params)).then(function (res) {
        var _res$data3, _res$data3$status;
        console.log('res send zalo', res);
        if ((res === null || res === void 0 ? void 0 : (_res$data3 = res.data) === null || _res$data3 === void 0 ? void 0 : (_res$data3$status = _res$data3.status) === null || _res$data3$status === void 0 ? void 0 : _res$data3$status.code) == 200) {
          appendNewMessage(chatContent);
        }
        setChatContent('');
      });
    } catch (e) {
      return Promise.reject(e);
    }
  };
  var appendNewMessage = function appendNewMessage(message) {
    var buildMessage = {};
    setMessages([].concat(buildMessage, messages));
  };
  return /*#__PURE__*/React__default.createElement("div", {
    style: _extends({
      flex: 1,
      display: 'flex',
      flexDirection: 'column',
      minWidth: 300,
      height: '100%'
    }, style)
  }, showChatHeader ? /*#__PURE__*/React__default.createElement("div", {
    style: {
      padding: 12,
      height: 64,
      width: '100%'
    },
    className: "box-shadow"
  }, /*#__PURE__*/React__default.createElement("div", {
    style: {
      display: 'inline-flex',
      alignItems: 'center'
    }
  }, /*#__PURE__*/React__default.createElement("img", {
    src: conversationDetail === null || conversationDetail === void 0 ? void 0 : conversationDetail.displayAvatar,
    style: {
      width: 40,
      height: 40,
      borderRadius: 20,
      objectFit: 'cover',
      backgroundColor: '#f1f1f1'
    }
  }), /*#__PURE__*/React__default.createElement("div", {
    style: {
      marginLeft: 12
    }
  }, /*#__PURE__*/React__default.createElement("div", null, conversationDetail === null || conversationDetail === void 0 ? void 0 : conversationDetail.displayName), /*#__PURE__*/React__default.createElement(antd.Space, {
    size: 0,
    style: {
      marginTop: 4
    }
  }, tag === null || tag === void 0 ? void 0 : tag.map(function (e) {
    return /*#__PURE__*/React__default.createElement(antd.Tag, {
      color: e === null || e === void 0 ? void 0 : e.color
    }, e === null || e === void 0 ? void 0 : e.name);
  }))))) : null, fetchingData && !(conversationDetailParams !== null && conversationDetailParams !== void 0 && conversationDetailParams.page) ? /*#__PURE__*/React__default.createElement("div", {
    style: {
      flex: 1,
      padding: 24
    }
  }, /*#__PURE__*/React__default.createElement(antd.Skeleton, {
    loading: true,
    active: true,
    avatar: true
  }), /*#__PURE__*/React__default.createElement(antd.Skeleton, {
    loading: true,
    active: true,
    avatar: true
  }), /*#__PURE__*/React__default.createElement(antd.Skeleton, {
    loading: true,
    active: true,
    avatar: true
  })) : /*#__PURE__*/React__default.createElement(MessagesRender, {
    ref: messagesRef,
    chatId: conversationDetail === null || conversationDetail === void 0 ? void 0 : conversationDetail.chatId,
    messages: messages,
    startReached: startReached,
    START_INDEX: startIndex,
    type: CONST.CONVERSATION_TYPE.ZALO
  }), /*#__PURE__*/React__default.createElement("div", {
    style: {
      padding: 12,
      display: 'flex',
      flexDirection: 'row',
      alignItems: 'flex-end'
    }
  }, /*#__PURE__*/React__default.createElement(antd.Input.TextArea, {
    placeholder: "Nh\u1EADp n\u1ED9i dung",
    value: chatContent,
    onChange: function onChange(e) {
      var _e$target;
      return setChatContent(e === null || e === void 0 ? void 0 : (_e$target = e.target) === null || _e$target === void 0 ? void 0 : _e$target.value);
    },
    autoSize: {
      minRows: 1,
      maxRows: 6
    },
    style: {
      flex: 1
    }
  }), /*#__PURE__*/React__default.createElement(SendOutlined$2, {
    style: {
      fontSize: 24,
      paddingLeft: 12,
      paddingBottom: 4,
      color: '#136DFB'
    },
    onClick: sendMessage
  })));
};

var ExampleComponent1 = function ExampleComponent1(_ref) {
  var text = _ref.text;
  return /*#__PURE__*/React__default.createElement("div", {
    className: styles.test
  }, "Example Component: ", text);
};

exports.CONST = CONST;
exports.ExampleComponent1 = ExampleComponent1;
exports.FbConversationDetail = FbConversationDetail;
exports.FbConversations = FbConversations;
exports.ZaloConversationDetail = ZaloConversationDetail;
exports.ZaloConversations = ZaloConversations;
//# sourceMappingURL=index.js.map
